 
      PROGRAM ADRV 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
      USE params_M 
      USE tfiles_dat_M 
!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
!...Switches: -yf12               
! Version      10 May 1996
! tmpprf=GasPrf(i,iretgas) and GasPrf(i,iretgas)=tmpprf
! to decrease the running difference between machines.
!
! Version 2.01 22 Feb 1996
! Brian Connor
! parameter values updates 29 March 96 - BJC
!      parameter(nmax=100,mmax=10000,maxgasrd=100,maxlev=50)
! Parameter statement removed 14 May 96 -John
! Version 3.74D (from version number in sfit2 subroutine)
! Resurected to compare with analytic AK calculation May 2000 -  Steve Wood
! Define maxgasrd and maxlev from items from params instead of
!  local declarations June 12 2001 - Steve Wood & Paul Manning
      IMPLICIT NONE
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      INTEGER, PARAMETER :: MAXGASRD = MOLTOTAL 
      INTEGER, PARAMETER :: MAXLEV = LAYMAX 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      INTEGER :: I, NRETGAS, NLEV, IGAS, J, IRETGAS, NGAS, NVAR, NFIT, K 
      REAL(DOUBLE), DIMENSION(MMAX) :: YHAT 
      REAL(DOUBLE), DIMENSION(NMAX) :: XHAT 
      REAL(DOUBLE), DIMENSION(MAXLEV) :: XRET0 
      REAL(DOUBLE), DIMENSION(MAXLEV,MAXLEV) :: XRET 
      REAL(DOUBLE), DIMENSION(MAXLEV,MAXGASRD) :: GASPRF 
      REAL(DOUBLE), DIMENSION(MAXLEV) :: Z, P, T 
      REAL(DOUBLE), DIMENSION(MAXLEV + 1) :: ZG 
      REAL(DOUBLE), DIMENSION(MAXLEV) :: ACOL 
      REAL(DOUBLE), DIMENSION(MAXLEV,MAXLEV) :: A 
      REAL(DOUBLE), DIMENSION(MAXLEV) :: XAPR, DZ, DMIX 
      REAL(DOUBLE), POINTER, DIMENSION(:) :: INVAR1 
      REAL(DOUBLE) :: PERT, TACOL, GASCOL, TMPPRF 
      LOGICAL :: RETFLG, WRTK 
      CHARACTER :: CTLFIL*(IFLNMSZ), PT*(IFLNMSZ), MX*(IFLNMSZ), &
           MS*(IFLNMSZ), INP_SPC*(IFLNMSZ), OUT_SPC*(IFLNMSZ),&
           MX_PRT*(IFLNMSZ), DUM*(IFLNMSZ), OUT_AKER*(IFLNMSZ), &
           RETGAS*7 
      CHARACTER, DIMENSION(MAXGASRD) :: GAS*7 
!-----------------------------------------------
!     parameter(maxgasrd=100,maxlev=50)
!      real*8 yhat(mmax),xhat(nmax),xret0(maxlev),xret(maxlev,maxlev)
!      real*4 GasPrf(maxlev,maxgasrd),z(maxlev),p(maxlev),t(maxlev),
 
      MX_PRT = 'mx_prt' 
! open and read adrv control file
      OPEN(1, FILE='adrv.ctl', STATUS='old', ERR=1000, POSITION='asis') 
      READ (1, 10) CTLFIL 
      READ (1, 10) PT 
      READ (1, 10) MS 
      READ (1, 10) MX 
      READ (1, 10) INP_SPC 
      READ (1, 10) OUT_SPC 
      READ (1, *) PERT 
      READ (1, 10) OUT_AKER 
      CLOSE(1) 
! open sfit2 control file; read first gas name and number of levels
      OPEN(1, FILE=CTLFIL, STATUS='old', ERR=1010, POSITION='asis') 
      DO I = 1, 8 
         READ (1, 10) 
      END DO 
      READ (1, *) NRETGAS 
      READ (1, 20) RETGAS 
      READ (1, *) NLEV 
      CLOSE(1) 
!      write(*,*)nRetGas,RetGas,nlev
! read mixing ratio file
      OPEN(2, FILE=MX, STATUS='old', ERR=1020, POSITION='asis') 
      IGAS = 0 
!   do while (.not. eof(2))
  101 CONTINUE 
      IGAS = IGAS + 1 
      READ (2, 20, END=102) GAS(IGAS) 
      READ (2, *) (GASPRF(J,IGAS),J=1,NLEV) 
      IF (GAS(IGAS) == RETGAS) THEN 
         IRETGAS = IGAS 
!         write(*,*)'found gas ',RetGas
         XAPR(:NLEV) = GASPRF(:NLEV,IGAS) 
!          write(*,*)i,xapr(i)
      ENDIF 
      GO TO 101 
!   end do
  102 CONTINUE 
      CLOSE(2) 
      NGAS = IGAS 
! read atmosphere file
      OPEN(3, FILE=PT, STATUS='old', ERR=1030, POSITION='asis') 
      ZG(1) = 100. 
      DO I = 1, NLEV 
         READ (3, *) ZG(I+1), P(I), T(I) 
         DZ(I) = ZG(I) - ZG(I+1) 
         Z(I) = ZG(I+1) + DZ(I)/2 
      END DO 
      CLOSE(3) 
      ALLOCATE (INVAR1(NLEV)) 
      INVAR1 = Z(1:NLEV) 
! calc. air, gas columns
      TACOL = 0. 
      ACOL(:NLEV) = DZ(:NLEV)*1.E5*P(:NLEV)*1000./(1.38062E-16*T(:NLEV)) 
      GASCOL = GASCOL + DOT_PRODUCT(ACOL(:NLEV),XAPR(:NLEV)) 
! do initial retrieval
      WRITE (*, *) ' first do unperturbed case' 
!    first, forward calc.
      WRTK = .FALSE. 
      RETFLG = .FALSE. 
      WRITE (*, *) 'entering sfit2 (forward)' 
      WRITE (*, *) CTLFIL, INP_SPC, OUT_SPC, PT, MS, MX, NFIT, NVAR, NLEV, &
         RETFLG, WRTK 
      CALL SFIT2 (CTLFIL, INP_SPC, OUT_SPC, PT, MS, MX, XHAT, YHAT, NFIT, NVAR&
         , NLEV, RETFLG, WRTK) 
      WRITE (*, *) 'leaving sfit2' 
!    then retrieval
      RETFLG = .TRUE. 
      WRITE (*, *) 'entering sfit2 (retrieve)' 
      CALL SFIT2 (CTLFIL, OUT_SPC, DUM, PT, MS, MX, XHAT, YHAT, NFIT, NVAR, &
         NLEV, RETFLG, WRTK) 
      WRITE (*, *) 'leaving sfit2' 
      XRET0(:NLEV) = XHAT(NVAR-NLEV+2-NRETGAS:1+NVAR-NRETGAS)*XAPR(:NLEV) 
! enter perturbation loop
      DO I = 1, NLEV 
         WRITE (*, *) 'Doing perturbation # ', I, ' of ', NLEV 
         DMIX(I) = PERT*GASCOL/ACOL(I) 
!     perturb profile
         TMPPRF = GASPRF(I,IRETGAS) 
         GASPRF(I,IRETGAS) = GASPRF(I,IRETGAS) + DMIX(I) 
         OPEN(4, FILE=MX_PRT, STATUS='unknown', ERR=1040, POSITION='asis') 
         DO K = 1, NGAS 
            WRITE (4, 20) GAS(K) 
            WRITE (4, *) (GASPRF(J,K),J=1,NLEV) 
         END DO 
         CLOSE(4) 
!     restore unperturbed value
         GASPRF(I,IRETGAS) = TMPPRF 
! do ith retrieval
!    first, forward calc.
         RETFLG = .FALSE. 
         WRTK = .FALSE. 
         WRITE (*, *) 'entering sfit2 (forward)' 
         CALL SFIT2 (CTLFIL, INP_SPC, OUT_SPC, PT, MS, MX_PRT, XHAT, YHAT, NFIT&
            , NVAR, NLEV, RETFLG, WRTK) 
         WRITE (*, *) 'leaving sfit2' 
!    then retrieval
         RETFLG = .TRUE. 
         WRITE (*, *) 'entering sfit2 (retrieve)' 
         CALL SFIT2 (CTLFIL, OUT_SPC, DUM, PT, MS, MX, XHAT, YHAT, NFIT, NVAR, &
            NLEV, RETFLG, WRTK) 
         WRITE (*, *) 'leaving sfit2' 
         XRET(:NLEV,I) = XHAT(NVAR-NLEV+2-NRETGAS:1+NVAR-NRETGAS)*XAPR(:NLEV) 
      END DO 
! now calculate A
      WRITE (*, *) 'calculating A' 
      DO I = 1, NLEV 
         A(:NLEV,I) = ACOL(:NLEV)/ACOL(I)*(XRET(:NLEV,I)-XRET0(:NLEV))/DMIX(I) 
      END DO 
! write output file
      OPEN(7, FILE=OUT_AKER, STATUS='unknown', ERR=1050, POSITION='asis') 
      WRITE (7, 10) CTLFIL 
      WRITE (7, 10) PT 
      WRITE (7, 10) MS 
      WRITE (7, 10) MX 
      WRITE (7, *) NLEV, PERT 
      WRITE (7, *) INVAR1 
      DO I = 1, NLEV 
         WRITE (7, *) (A(I,J),J=1,NLEV) 
      END DO 
   10 FORMAT(A30) 
   20 FORMAT(A7) 
      STOP  
 1000 CONTINUE 
      WRITE (*, *) 'Error opening file "adrv.ctl"' 
      STOP  
 1010 CONTINUE 
      WRITE (*, *) 'Error opening rdrv.ctl file' 
      WRITE (*, *) 'Filename: "', CTLFIL, '"' 
      STOP  
 1020 CONTINUE 
      WRITE (*, *) 'Error opening mx file' 
      WRITE (*, *) 'Filename: "', MX, '"' 
      STOP  
 1030 CONTINUE 
      WRITE (*, *) 'Error opening pt file' 
      WRITE (*, *) 'Filename: "', PT, '"' 
      STOP  
 1040 CONTINUE 
      WRITE (*, *) 'Error opening mx_prt file' 
      WRITE (*, *) 'Filename: "', MX_PRT, '"' 
      STOP  
 1050 CONTINUE 
      WRITE (*, *) 'Error opening out_aker file' 
      WRITE (*, *) 'Filename: "', OUT_AKER, '"' 
      STOP  
      END PROGRAM ADRV 
