      REAL(KIND(0.0D0)) FUNCTION APDZ (X) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
      USE params_M 
      USE jmix_dat_M
      USE zfft_dat_M
      USE ils_dat_M 

!      CALCULATE APPLIED APODIZING FUNCTION FOR SFIT2- REVISED:  JULY 3, 1997
!      APODIZING FUNCTIONS 0-3 FROM
!        REF: NORTON AND BEER, J. OPT. SOC. AMER. 66, 259 (1976).
!           REVISED COEFFICIENTS FROM J. OPT. SOC. AMER. 67, 419 (1977)
 
      IMPLICIT NONE
      REAL(DOUBLE) :: X 

      REAL(DOUBLE) :: W, PART 

      APDZ = 0.0D0
      IF (IAP>=0 .AND. IAP<=9) THEN 
         IF (IAP <= 4) THEN 
!  --- NORTON AND BEER APODZING FUNCTIONS
            IF (X >= PMAX) THEN 
               APDZ = 0.0D0 
               RETURN  
            ENDIF 
            W = 1.0D0 - (X/PMAX)**2 
            APDZ = C0 + C1*W + C2*W*W + C4*W*W*W*W 
            RETURN  
         ENDIF 
         IF (IAP <= 5) THEN 
!  --- IAP=5 (TRIANGLE APODIZING FUNCTION)
            APDZ = 1.0D0 - X/PMAX 
            RETURN  
         ENDIF 
         IF (IAP <= 6) THEN 
!  --- IAP=6 (HAPP-GENZEL)
            APDZ = 0.54D0 + 0.46D0*COS(3.14159D0*X/PMAX) 
            RETURN  
         ENDIF 
!  --- IAP=7 (KPNO ATMOSPHERIC SPECTRA)
         IF (IAP > 7) GO TO 104 
         APDZ = 1.D0 
         PART = X/PMAX 
         IF (PART <= 0.9D0) RETURN  
         IF (PART <= 1.0D0) THEN 
!  --- APPLY COSIGN SQUARE TO TAIL OF INTERFEROGRAM
            PART = 10.D0*(PART - 0.9D0) 
            PART = 1.570795D0*PART 
            APDZ = COS(PART) 
            APDZ = APDZ*APDZ 
            RETURN  
         ENDIF 
   15    CONTINUE 
         APDZ = 0.D0 
         RETURN  
!  --- IAP=8 (KPNO ATMOSPHERIC SPECTRA)
  104    CONTINUE 
         IF (IAP <= 8) THEN 
            APDZ = 1.D0 
            PART = X/PMAX 
            IF (PART <= 0.95D0) RETURN  
            IF (PART > 1.0D0) GO TO 15 
!  --- APPLY COSIGN SQUARE TO TAIL OF INTERFEROGRAM
            PART = 10.D0*(PART - 0.95D0) 
            PART = 1.570795D0*PART 
            APDZ = COS(PART) 
            APDZ = APDZ*APDZ 
            RETURN  
         ENDIF 
!  IAP=9  HAMMING FUNCTION
         PART = X/PMAX 
         APDZ = 0.53856D0 + 0.46144D0*COS(3.141592654D0*PART) 
         IF (PART > 1.D0) APDZ = 0.D0 
         RETURN  
      ENDIF 
!      YOU HAVE ASKED FOR NON-EXISTANT APODIZATION
      WRITE (16, 11) IAP 
   11 FORMAT(' NO SUCH APODIZING FUNCTION - IAP =',I4) 
      STOP 'APDZ' 
      END FUNCTION APDZ 
