      MODULE bands_dat_M 

! Note: lines end with PWJ are revised by Wujian Peng in July,2002  !pwj

! parameters defined in params.inc :
! MAXBND 	: MAXIMUM NUMBER OF BANDPASSES
! MAXSPE	: MAXIMUM NUMBER OF SPECTRA
! MOLMAX 	: MAXIMUM NUMBER OF MOLECULES
! NMAX 		: MAXIMUM NUMBER OF VARIABLES

! variables declared here 
! NFITS		: TOTAL NUMBER OF SPECTRAL SEGMENTS FITTED


      USE vast_kind_param
!...Created by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
      USE params_M

      REAL(DOUBLE), DIMENSION(MAXBND) :: WAVE3  ! BEGINNING WAVENUMBER FOR 
                                                ! INTEGRATION
      REAL(DOUBLE), DIMENSION(MAXBND) :: WAVE4  ! ENDING WAVENUMBER FOR 
                                                ! INTEGRATION
      REAL(DOUBLE), DIMENSION(MAXBND) :: WAVE5  ! BEGINNING WAVENUMBER FOR 
                                                ! LINE LIST
      REAL(DOUBLE), DIMENSION(MAXBND) :: WAVE6  ! ENDING WAVENUMBER FOR 
                                                ! LINE LIST
      REAL(DOUBLE), DIMENSION(MAXBND) :: WSTART
      REAL(DOUBLE), DIMENSION(MAXBND) :: WSTOP
      REAL(DOUBLE), DIMENSION(MAXBND) :: WMON
      INTEGER, DIMENSION(MAXBND,MOLMAX) :: IGASB ! GASES RETRIEVED IN BAND I
      INTEGER, DIMENSION(MOLMAX,0:2,0:MAXBND) :: NGIDX 
      			! INDEX REGION IN PARM OF GAS I AND FLAG BAND 
      			! i,0,k is flag that gas i is in band k
      			! i,1,k is lower index in parm
      			! i,2,k is upper index in parm      			      			
      INTEGER, DIMENSION(MAXBND,MAXSPE) :: ISCAN ! SPECTRUM CODE FOR THE 
                                                 ! I BAND J SCAN (1000*SZA)
                                                 
      INTEGER, DIMENSION(2,MAXBND,MAXSPE) :: ISCNDX 
                ! low, high index of spectra in K by band and scan                                                 
      INTEGER, DIMENSION(MAXBND,MOLMAX) :: MINB 
      INTEGER, DIMENSION(MAXBND,MOLMAX) :: MAXB
      INTEGER, DIMENSION(MAXBND) :: NM	   ! NUMBER OF POINTS IN TCALC BY BAND
      INTEGER, DIMENSION(MAXBND) :: NPRIM ! NUMBER OF POINTS IN OBS SPEC BY BAND
      INTEGER, DIMENSION(MAXBND) :: NRETB ! NUMBER OF MOLEC RETRIEVED BY BAND
      INTEGER, DIMENSION(MAXBND) :: NSCAN ! NUMBER OF SCANS TO BE FIT FOR
                                          ! A GIVEN BANDPASS (IBAND)
      INTEGER, DIMENSION(MAXBND) :: IZERO 
      INTEGER, DIMENSION(MOLMAX) :: MINZ  ! MINIMUM ALTITUDE RETRIEVED FOR 
                                          ! RETRIEVAL GAS I
      INTEGER, DIMENSION(MOLMAX) :: MAXZ  ! MAXIMUM ALTITUDE RETRIEVED FOR 
                                          ! RETRIEVAL GAS I
      INTEGER, DIMENSION(MOLMAX) :: NUMZ  ! NUMBER OF ALTITUDES TO BE FIT 
                                          ! FOR RETRIEVAL GAS I
!        these next 2 may not be used
      INTEGER, DIMENSION(MOLMAX) :: IRETS ! SPECTRUM NUMBER OF FIRST SCAN 
                                          ! RETRIEVED FOR GAS I
      INTEGER, DIMENSION(MOLMAX) :: IRETF ! SPECTRUM NUMBER OF FINAL SCAN 
                                          ! RETRIEVED FOR GAS I
      REAL(DOUBLE), DIMENSION(MAXBND,MAXSPE) :: ZSHIFT
        				! ZERO SHIFTS BY BAND AND SCAN
      INTEGER, DIMENSION(MAXBND) :: NBEAM_OF_BAND ! NUMBER OF BEAMS IN THIS 
                                                  ! BAND (pwj)
      CHARACTER, DIMENSION(MAXBND) :: CHANNEL_MODEL_OF_BAND*2 
                         ! TWO VALID VALUES:
                         !   'IP' -- INTEFEROGRAM PERTURBATION MODE    !PWJ
                         !   'PS' -- PHASE-SHIFTED REFLECTED BEAM      !PWJ
      REAL(DOUBLE), DIMENSION(MAXBND,MAX_NUM_OF_BEAMS,4) :: CCIPARM 
                                            ! CHANNEL SPECTRUM VALUES (pwj)
      REAL(DOUBLE), DIMENSION(MAXBND,MAX_NUM_OF_BEAMS,4) :: CHANNEL_CPARM
                                            ! CHANNEL SPECTRUM VALUES (pwj)
      INTEGER, DIMENSION(MAXBND,MAX_NUM_OF_BEAMS,4) :: CHANNEL_IFIX 
                                             ! CHANNEL SPECTRUM VALUES (pwj)		
      INTEGER :: FIRST_CHANNEL_PARM_NUM      ! THE POSITION OF FIRST CHANNEL 
                                             ! PARM IN STATE VECTOR  (pwj)
      INTEGER :: NBAND, NZERO, NFITS
      END MODULE bands_dat_M 
