      REAL(KIND(0.0D0)) FUNCTION EAPDZ (X, DX) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
      USE params_M 
      USE jmix_dat_M
      USE zfft_dat_M
!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
!...Switches: -yf12               
 
      IMPLICIT NONE
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      REAL(DOUBLE) :: X 
      REAL(DOUBLE) :: DX 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      INTEGER :: I, IMAX 
      REAL(DOUBLE) :: XP 
!-----------------------------------------------
 
      EAPDZ = 0.0D0
      XP = X/PMAX 
      SELECT CASE (IEAP)  
      CASE (1, 4)  
!       interpolate the apodization function to path difference x
         IF (X<EAPX(1) - DX .OR. X>EAPX(JEAP)+DX) THEN 
            WRITE (16, *) 'Path difference', X, ' is out of range of eapx' 
            STOP  
         ENDIF 
         DO I = 2, JEAP 
            IF (EAPX(I) <= X) CYCLE  
            IMAX = I 
            EXIT  
         END DO 
         EAPDZ = EAPF(IMAX-1) + (X - EAPX(IMAX-1))*(EAPF(IMAX)-EAPF(IMAX-1))/(&
            EAPX(IMAX)-EAPX(IMAX-1)) 
 
      CASE (2)  
!       eapdz is a polynomial with neap terms
         EAPDZ = 1.D0 
         DO I = 1, NEAP 
            EAPDZ = EAPDZ + (EAPF(I)-1.D0)*XP**I 
         END DO 
      CASE (3)  
!       eapdz is a Fourier series with neap frequencies
         EAPDZ = 1.D0 
         DO I = 1, NEAP 
            EAPDZ = EAPDZ + (1.D0 - EAPF(I+1))*SIN(2.D0*PI*I*EAPF(1)*XP) + (&
               1.D0 - EAPF(I+2))*COS(2.D0*PI*I*EAPF(1)*XP) 
         END DO 
 
      CASE DEFAULT 
         WRITE (0, *) ' eapdz.f : error ieap out of range (1-4) : ', IEAP 
         STOP  
      END SELECT 
 
      RETURN  
      END FUNCTION EAPDZ 
