      SUBROUTINE FFT(Z, MVAL, IWK) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
      USE params_M 
!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
!...Switches: -yf12               
      IMPLICIT NONE
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      INTEGER :: MVAL 
      INTEGER  :: IWK(*) 
      COMPLEX(DBLE_COMPLEX)  :: Z(*) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      INTEGER :: K01, J2, M, MP, N, I, MM, KN, MK, KB, K0, K2, JJ, K, J, ISP, &
         JSP, K1, K3 
      REAL(DOUBLE) :: A0, A1, A3, B1, B2, B3, CK, SK, SQ, ONE, ZERO, TWOPI, &
         SYGN, RAD, C1, C2, C3, S1, S2, S3, TEMP, XN, A2, B0 
      REAL(DOUBLE), DIMENSION(2) :: Z0, Z1, Z2, Z3 
      COMPLEX(DBLE_COMPLEX) :: ZA0, ZA1, ZA2, ZA3, AK2 
!-----------------------------------------------
!     E2.4
!***********************************************************************FFT    4
! VERSION TO RUN ON IBM PC-AT AND CLONES
! USES DOUBLE PREISION  REV DATE MAY 9,1987
!
!   FUNCTION            - COMPUTE THE FAST FOURIER TRANSFORM, GIVEN A
!                           COMPLEX VECTOR OF LENGTH EQUAL TO A POWER
!                           OF TWO
!   USAGE               - CALL FFT (Z,M,IWK)
!   PARAMETERS  Z       - COMPLEX VECTOR OF LENGTH N=2**M
!                           WHICH CONTAINS ON INPUT THE
!                           DATA TO BE TRANSFORMED. ON
!                           OUTPUT,A CONTAINS THE FOURIER
!                           COEFFICIENTS.
!                M      - N = 2**M IS THE NUMBER OF DATA POINTS.
!                         M= +N FFT WILL PERFORM FOURIER
!                             TRANSFORM.
!                         M= -N FFT WILL PERFORM INVERSE
!                             TRANSFORM.
!                IWK    - WORK AREA VECTOR OF LENGTH M+1.
!   PRECISION           - SINGLE
!   LANGUAGE            - FORTRAN
!   LATEST REVISION     - APRIL 16, 1980
!-----------------------------------------------------------------------FFT   25
!
!     IMPLICIT REAL ( KIND=8 )  (A-H,O-Z)
      EQUIVALENCE (ZA0, Z0(1)), (ZA1, Z1(1)), (ZA2, Z2(1)), (ZA3, Z3(1)), (A0, &
         Z0(1)), (B0, Z0(2)), (A1, Z1(1)), (B1, Z1(2)), (A2, Z2(1)), (B2, Z2(2)&
         ), (A3, Z3(1)), (B3, Z3(2)) 
      DATA SQ, SK, CK/ .70710678118655D0, .38268343236509D0, .92387953251129D0&
         /  
      DATA TWOPI/ 6.2831853071796D0/  
      DATA ZERO/ 0.0D0/  
      DATA ONE/ 1.0D0/  
!                                  SQ=SQRT2/2,SK=SIN(PI/8),CK=COS(PI/8)
!                                  TWOPI=2*PI
      SYGN = 1.0D0 
      IF (MVAL < 0) SYGN = -1.0D0 
      M = IABS(MVAL) 
      MP = M + 1 
      N = 2**M 
!     CMPEPSILON used for comparison --  IF (SYGN .NE. 1.0D0) THEN
      IF (ABS(SYGN - 1.0) > ABS(SYGN + 1.0)*CMPEPSILON) THEN 
         DO I = 1, N 
!        Z(I) = DCONJG(Z(I))
            Z(I) = CONJG(Z(I)) 
         END DO 
      ENDIF 
      IWK(1) = 1 
      MM = (M/2)*2 
      KN = N + 1 
!                                  INITIALIZE WORK VECTOR
      DO I = 2, MP 
         IWK(I) = IWK(I-1) + IWK(I-1) 
      END DO 
      RAD = TWOPI/N 
      MK = M - 4 
      KB = 1 
      IF (MM /= M) THEN 
         K2 = KN 
         K0 = IWK(MM+1) + KB 
         K01 = K0 
         J2 = MIN0(KB + 1,K01) 
         DO K0 = K01, J2, -1 
            K2 = K2 - 1 
            AK2 = Z(K2) 
            Z(K2) = Z(K0-1) - AK2 
            Z(K0-1) = Z(K0-1) + AK2 
         END DO 
      ENDIF 
      C1 = ONE 
      S1 = ZERO 
      JJ = 0 
      K = MM - 1 
      J = 4 
      IF (K >= 1) GO TO 30 
      GO TO 9005 
   20 CONTINUE 
      IF (IWK(J) > JJ) GO TO 25 
      JJ = JJ - IWK(J) 
      J = J - 1 
      IF (IWK(J) > JJ) GO TO 25 
      JJ = JJ - IWK(J) 
      J = J - 1 
      K = K + 2 
      GO TO 20 
   25 CONTINUE 
      JJ = IWK(J) + JJ 
      J = 4 
   30 CONTINUE 
      ISP = IWK(K) 
      IF (JJ == 0) GO TO 40 
!                                  RESET TRIGONOMETRIC PARAMETERS
      C2 = JJ*ISP*RAD 
      C1 = COS(C2) 
      S1 = SIN(C2) 
   35 CONTINUE 
      C2 = C1*C1 - S1*S1 
      S2 = C1*(S1 + S1) 
      C3 = C2*C1 - S2*S1 
      S3 = C2*S1 + S2*C1 
   40 CONTINUE 
      JSP = ISP + KB 
!                                  DETERMINE FOURIER COEFFICIENTS
!                                    IN GROUPS OF 4
      IF (S1 /= ZERO) THEN 
         DO I = 1, ISP 
            K0 = JSP - I 
            K1 = K0 + ISP 
            K2 = K1 + ISP 
            K3 = K2 + ISP 
            ZA0 = Z(K0) 
            ZA1 = Z(K1) 
            ZA2 = Z(K2) 
            ZA3 = Z(K3) 
            TEMP = A1 
            A1 = A1*C1 - B1*S1 
            B1 = TEMP*S1 + B1*C1 
            TEMP = A2 
            A2 = A2*C2 - B2*S2 
            B2 = TEMP*S2 + B2*C2 
            TEMP = A3 
            A3 = A3*C3 - B3*S3 
            B3 = TEMP*S3 + B3*C3 
            TEMP = A0 + A2 
            A2 = A0 - A2 
            A0 = TEMP 
            TEMP = A1 + A3 
            A3 = A1 - A3 
            A1 = TEMP 
            TEMP = B0 + B2 
            B2 = B0 - B2 
            B0 = TEMP 
            TEMP = B1 + B3 
            B3 = B1 - B3 
            B1 = TEMP 
!        Z(K0) = DCMPLX(A0+A1,B0+B1)
!        Z(K1) = DCMPLX(A0-A1,B0-B1)
!        Z(K2) = DCMPLX(A2-B3,B2+A3)
!        Z(K3) = DCMPLX(A2+B3,B2-A3)
            Z(K0) = CMPLX(A0 + A1,B0 + B1,KIND = 8) 
            Z(K1) = CMPLX(A0 - A1,B0 - B1,KIND = 8) 
            Z(K2) = CMPLX(A2 - B3,B2 + A3,KIND = 8) 
            Z(K3) = CMPLX(A2 + B3,B2 - A3,KIND = 8) 
         END DO 
      ELSE 
         DO I = 1, ISP 
            K0 = JSP - I 
            K1 = K0 + ISP 
            K2 = K1 + ISP 
            K3 = K2 + ISP 
            ZA0 = Z(K0) 
            ZA1 = Z(K1) 
            ZA2 = Z(K2) 
            ZA3 = Z(K3) 
            TEMP = A0 + A2 
            A2 = A0 - A2 
            A0 = TEMP 
            TEMP = A1 + A3 
            A3 = A1 - A3 
            A1 = TEMP 
            TEMP = B0 + B2 
            B2 = B0 - B2 
            B0 = TEMP 
            TEMP = B1 + B3 
            B3 = B1 - B3 
            B1 = TEMP 
!        Z(K0) = DCMPLX(A0+A1,B0+B1)
!        Z(K1) = DCMPLX(A0-A1,B0-B1)
!        Z(K2) = DCMPLX(A2-B3,B2+A3)
!        Z(K3) = DCMPLX(A2+B3,B2-A3)
            Z(K0) = CMPLX(A0 + A1,B0 + B1,KIND = 8) 
            Z(K1) = CMPLX(A0 - A1,B0 - B1,KIND = 8) 
            Z(K2) = CMPLX(A2 - B3,B2 + A3,KIND = 8) 
            Z(K3) = CMPLX(A2 + B3,B2 - A3,KIND = 8) 
         END DO 
      ENDIF 
      IF (K <= 1) GO TO 55 
      K = K - 2 
      GO TO 30 
   55 CONTINUE 
      KB = K3 + ISP 
!                                  CHECK FOR COMPLETION OF FINAL
!                                    ITERATION
      IF (KN <= KB) GO TO 9005 
      IF (J /= 1) GO TO 60 
      K = 3 
      J = MK 
      GO TO 20 
   60 CONTINUE 
      J = J - 1 
      C2 = C1 
      IF (J /= 2) GO TO 65 
      C1 = C1*CK + S1*SK 
      S1 = S1*CK - C2*SK 
      GO TO 35 
   65 CONTINUE 
      C1 = (C1 - S1)*SQ 
      S1 = (C2 + S1)*SQ 
      GO TO 35 
 9005 CONTINUE 
!     CMPEPSILON used for comparison -- IF (SYGN .NE. 1.D0)  THEN 
      IF (ABS(SYGN - 1.D0) > ABS(SYGN + 1.D0)*CMPEPSILON) THEN 
         XN = N 
         DO I = 1, N 
!     Z(I)=DCONJG(Z(I))/XN
            Z(I) = CONJG(Z(I))/XN 
         END DO 
      ENDIF 
      CALL QXZ136 (Z, M, IWK) 
      RETURN  
      END SUBROUTINE FFT 
