      SUBROUTINE FSPEC2(IBAND, MONONE, PHI) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
      USE params_M 
      USE jmix_dat_M
      USE zfft_dat_M
      USE bands_dat_M
      USE trans_dat_M 
      USE spec_dat_M
      USE YFFT_M 
!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
!...Switches: -yf12               
!      APPLY APODIZATION AND PHASE ERROR TO INTERFEROGRAM
!      COMPUTE  COMPLEX SPECTRUM BY TAKING INVERSE FFT
!      REVISED  SEPT 24, 1996  CPR
 
      IMPLICIT NONE
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      INTEGER :: IBAND 
      INTEGER :: MONONE 
      REAL(DOUBLE) :: PHI 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      INTEGER, DIMENSION(:),ALLOCATABLE :: IW
      INTEGER :: NZ1, NZ2, NMON, LF, I, MINUS, NAERR
      REAL(DOUBLE) :: WMEAN, DX, PHI0, X, AP, FACTOR, T2, T4, T6, T8 
!-----------------------------------------------
!   E x t e r n a l   F u n c t i o n s
!-----------------------------------------------
      REAL(DOUBLE) , EXTERNAL :: EPHS, EAPDZ, APDZ 
!-----------------------------------------------
!
!      REAL*4 TOBS
 
      WMEAN = (WSTOP(IBAND)-WSTART(IBAND))/2.D0 + WSTART(IBAND) 
!
!      APODIZE AND FIELD OF VIEW CORRECTION
!
      NZ1 = NSTZ1(IBAND) 
      NZ2 = NSTZ2(IBAND) 
      NMON = NM(IBAND) 
      LF = LOWFIL(IBAND) 
 
 
!  ---  PHASE ERROR
! add phase function (same for all bandpasses and spectra) to phase
! constants retrieved for each bandpass and spectrum
!
      DX = 1.D0/(MPT(IBAND)*DN) 
      PHI0 = PHI 
      DO I = 1, NZ1 
         X = I/(MPT(IBAND)*DN) 
         IF (IEPHS > 0) PHI = PHI0 + EPHS(X,DX) 
         IMGG(I+1) = IMGG(I+1)*EXP(CMPLX(0.D0,(-PHI),KIND = 8)) 
         IMGG(MPT(IBAND)+1-I) = CONJG(IMGG(I+1)) 
      END DO 
!
!  --- CENTER FRINGE
      X = 0.D0 
      IF (IEPHS > 0) PHI = PHI0 + EPHS(X,DX) 
      IMGG(1) = IMGG(1)*EXP(CMPLX(0.D0,(-PHI),KIND = 8)) 
!
!      APODIZE AND FIELD OF VIEW CORRECTION
!
      DO I = 1, NZ1 
         X = I/(MPT(IBAND)*DN) 
! model empirical apodization
         AP = 1.D0 
         IF (IEAP > 0) AP = EAPDZ(X,DX) 
!  --- CONSTRAIN TO BE POSITIVE
         AP = DMAX1(0.D0,AP) 
         FACTOR = WMEAN*X*OMEGA/2.D0 
         IF (FACTOR <= 0.7D0) THEN 
            T2 = FACTOR*FACTOR 
            T4 = T2*T2 
            T6 = T4*T2 
            T8 = T4*T4 
            FACTOR = 1.D0 - T2/6.D0 + T4/120.D0 - T6/5040.D0 + T8/362880.D0 
         ELSE 
            FACTOR = SIN(FACTOR)/FACTOR 
         ENDIF 
         IMGG(I+1) = IMGG(I+1)*FACTOR*AP*APDZ(X) 
         IMGG(MPT(IBAND)+1-I) = IMGG(MPT(IBAND)+1-I)*FACTOR*AP*APDZ(X) 
      END DO 
      IMGG(NZ1:NZ2) = 0.D0 
      ALLOCATE (IW(MFFT(IBAND)+1), STAT=NAERR)
      IF (NAERR /= 0) THEN
        WRITE (6, *) 'Could not allocate IW array'
        WRITE (6, *) 'Error Number = ', NAERR
        STOP 'FSPECT2 ALLOCATION'
      ENDIF
      MINUS = -MFFT(IBAND) 
!
!     COMPLEX INVERSE TRANSFORM
      CALL FFT (IMGG, MINUS, IW) 
!
!     ADD OFFSET AND STORE IN TCONV ARRAY
      TCONV(MONONE:NMON-1+MONONE) = IMGG(1+LF:NMON+LF) + AMP 
      DEALLOCATE(IW)
      RETURN  
      END SUBROUTINE FSPEC2 
