      SUBROUTINE KROSSR 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
      USE params_M 
      USE jmix_dat_M
      USE slat_dat_M
      USE line_dat_M
      USE trans_dat_M 
      USE bands_dat_M
      USE vibfn_dat_M
      USE xsect_dat_M 
      USE molec_dat_M
      USE tips
      USE isotope
!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
!...Switches: -yf12               
!  ---
!     COMPUTE INITIAL OPTICAL DEPTHS FOR ALL LAYERS
!      REVISION DATE:  JULY 16, 1996
!  ---
!  --- DECLARE VARIABLES INTEGER(KIND=4) TO AVOID OVERFLOW
!  --- IN PRESSURE-BROADENED LOWER LAYERS
 
      IMPLICIT NONE
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      INTEGER :: JSTART, JSTOP, N1, K, I, J, INDXX, IBAND, LMIN, LMAX, &
         N, IMOL, NPOINT, MO, ISO
      REAL(DOUBLE) :: DIST, TXE, VIBFAC, STIMFC, SSL, ACOFB, SCOFB, ALOR, ADOP&
         , AKZERO, YDUM, OPTMAX, XDUM, AKV, OPTCEN, DELLOR, WLIN, START, SSTOP, &
         ANUZ, QT, QTSTDTEMP, GI, SSLOLD, BETAP, GZ
      LOGICAL prtdebug
!-----------------------------------------------
!   E x t e r n a l   F u n c t i o n s
!-----------------------------------------------
      REAL(DOUBLE) , EXTERNAL :: VOIGT 
      REAL(DOUBLE) , EXTERNAL :: GALATRY 
      REAL(DOUBLE) , EXTERNAL :: BETAT
!-----------------------------------------------
!
 
      WRITE (*, 1000) 
!  --- INITIALIZE X-SECTION ARRAYS
      N1 = NRET + 1 
      CROSS(:N1,:KMAX,:NCROSS) = 0.D0 
      INDXX = 0 
!                   ------------LOOP OVER BANDPASSES
      DO IBAND = 1, NBAND 
!                   ------------LOOP OVER LAYERS
         DO K = 1, KMAX 
!                    ---------- LOOP OVER SPECTRAL LINES
            LMIN = LINE1(IBAND) 
            LMAX = LINE2(IBAND) 
            DO N = LMIN, LMAX 
!   --- SELECT DISTANCE FROM LINE CENTER FOR CALCULATIONS
               DIST = DELNU 
               IF( IFMIX(LGAS(N)) == 0 ) CYCLE
               IMOL = LGAS(N) 
               TXE = RCONST2*ETWO(N)*(1.D0/T(K)-1.D0/STDTEMP) 
!              ... DEFAULT MOL AND ISO ID
               MO=ICODE(IMOL)
               ISO=ISCODE(IMOL)
!  --- CHECK FOR ISOTOPE SEPARATION
               DO I=1, NISOSEP
                   IF((MO .EQ. NEWID(I)) .AND. (ISO .EQ. NEWISO(I)))THEN
!                       print *,'TIPS CALC with ',OLDID(I),OLDISO(I),' FOR ',MO,ISO
                       MO = OLDID(I)
                       ISO = OLDISO(I)
                   ENDIF
               ENDDO   

               CALL BD_TIPS_2008_SFIT2(MO, STDTEMP, ISO, GI, QTSTDTEMP)
               CALL BD_TIPS_2008_SFIT2(MO, T(K), ISO, GI, QT)
               STIMFC = (1.D0 - EXP((-RCONST2*AZERO(N)/T(K))))/(1.D0 - EXP((-&
                  RCONST2*AZERO(N)/STDTEMP))) 
               VIBFAC = QV(IMOL,KMAX+1)/QV(IMOL,K) 
               SSLOLD = ST296(N)*(STDTEMP/T(K))*(STDTEMP/T(K))**TDEP(ICODE(IMOL))*&
                     VIBFAC*STIMFC*EXP((-TXE))
!               prtdebug= (iband == 1 .and. k == 1 .and. MOD(N,20) .eq. 0)
               prtdebug= .false.
               if (prtdebug) then
               print *
               print *,"IBAND,K,N,ID1,ID2,QT,QTSTD,T(K)=", &
                        iband,K,N,ICODE(IMOL),ISCODE(IMOL),QT,QTSTDTEMP,T(K)
               print *,"   VIB PART RESULT =", &
                    (STDTEMP/T(K))*(STDTEMP/T(K))**TDEP(ICODE(IMOL))*VIBFAC
               endif

               IF (QTSTDTEMP <= 0.0 .OR. QT <= 0.0) THEN
!                 ... USE NON-TIPS METHOD
!               VIBRATIONAL PARTITION FUNCTION
!                  VIBFAC = QV(IMOL,KMAX+1)/QV(IMOL,K) 
!               --- STIMULATED EMISSION CORRECTION TO LINE INTENSITY
!                  SSL = ST296(N)*(STDTEMP/T(K))*(STDTEMP/T(K))**TDEP(ICODE(IMOL))*&
!                     VIBFAC*STIMFC*EXP((-TXE))
                  SSL = SSLOLD
                  if (prtdebug) then
                     print *,"   VIB PARTITION SSL =",SSL
                  endif
               ELSE
!                 ... USE TIPS
                  SSL = ST296(N)*(STDTEMP/T(K))*(QTSTDTEMP/QT)*STIMFC*EXP((-TXE))
                  if (prtdebug) then
                     print *,"   QTSTDTEMP/QT=",QTSTDTEMP/QT
                     print *,"   TIPS SSL, VIB PARTITION SSL =",SSL,SSLOLD
                  endif
               ENDIF 
               ACOFB = AAA(N)*P(K)*(1.0D0 - XGAS(IMOL,K)) 
               SCOFB = SSS(N)*P(K)*XGAS(IMOL,K) 
               ALOR = (ACOFB + SCOFB)*(STDTEMP/T(K))**TDLIN(N) 
               ADOP = RFACTOR*SQRT(T(K)/GMASS(N))*AZERO(N) 
               AKZERO = SSL/ADOP*ALOGSQ/PISQ 
               YDUM = ALOGSQ*ALOR/ADOP 
               DO I = 1, NRET 
                  IF (LGAS(N) /= IRET(I)) CYCLE  
                  NPOINT = I 
                  OPTMAX = PMASMX(K)*XORG(I,K) 
                  GO TO 349 
               END DO 
               NPOINT = NRET + 1 
               OPTMAX = PMASMX(K)*XGAS(IMOL,K) 
!  --- CALCULATE LINE CENTER OPTICAL DEPTH
  349          CONTINUE 
               XDUM = 0.D0 
               IF (USEGALATRY) THEN
                  ! USE GALATRY FOR ALL LINES
                  IF (BETA(N) /= 0.0) THEN
                     ! USE BETA0 TO CALCULATE Z
                     BETAP = BETA(N)*P(K)
                     BETAP = BETAP * BETAT(ICODE(IMOL),T(K))
                     GZ = ALOGSQ*BETAP/ADOP
                     AKV = AKZERO*GALATRY(XDUM,YDUM,GZ) 
                  ELSE
                     ! NO BETA0 SO USE 0.0 FOR Z
                     GZ=0.0
                     AKV = AKZERO*GALATRY(XDUM,YDUM,GZ) 
                  ENDIF
               ELSE
                  ! USE VOIGT FOR ALL LINES
                  AKV = AKZERO*VOIGT(XDUM,YDUM) 
               ENDIF
               OPTCEN = AKV*OPTMAX 
!  --- SKIP OVER LINE IF OPTICAL DEPTH AT LINE CENTER IS LESS
!  --- THAN TAUMIN
               IF (OPTCEN < TAUMIN) CYCLE  
!  --- CALCULATE DISTANCE FROM LINE CENTER CORRESPONDING TO OPTICAL
!  --- DEPTH OF TAUMIN FOR A LORENTZ LINE
               DELLOR = SQRT(SSL*ALOR*OPTMAX/(TAUMIN*PI)) 
!  --- EXTEND CALCULATIONS FURTHER INTO THE WINGS IF NECESSARY
               IF (DELLOR > DELNU) DIST = DELLOR 
!  --- CORRECT POSITION FOR PRESSURE SHIFT
               WLIN = AZERO(N) + P(K)*PSLIN(N) 
!  --- ASSUME NO PRESSURE SHIFT
               IF (IFPS == 1) WLIN = AZERO(N) 
               START = WLIN - DIST 
               SSTOP = WLIN + DIST 
               JSTART = FLOOR((START - WMON(IBAND))/DN + 1.00000001D0)
               JSTOP = FLOOR((SSTOP - WMON(IBAND))/DN + 1.00000001D0)
               !print *, "krossr jstart, jstop ", jstart, jstop
               IF (JSTOP < 1) CYCLE  
               IF (JSTART > NM(IBAND)) CYCLE  
               JSTART = MAX0(1,JSTART) 
               JSTOP = MIN0(NM(IBAND),JSTOP) 
               DO J = JSTART, JSTOP 
                  ANUZ = WMON(IBAND) + (J - 1)*DN 
                  XDUM = ALOGSQ*(ANUZ - WLIN)/ADOP 
                  XDUM = ABS(XDUM) 
                  IF (USEGALATRY) THEN
                     AKV = AKZERO*GALATRY(XDUM,YDUM,GZ) 
                  ELSE
                     AKV = AKZERO*VOIGT(XDUM,YDUM) 
                  ENDIF
                  CROSS(NPOINT,K,J+INDXX) = CROSS(NPOINT,K,J+INDXX) + AKV*OPTMAX
               END DO 
            END DO 
         END DO 
         INDXX = INDXX + NM(IBAND) 
      END DO 
      WRITE (*, 1001) 
 1000 FORMAT('  Beginning cross section calculations...') 
 1001 FORMAT('  Cross section calculations completed.') 
      RETURN  
      END SUBROUTINE KROSSR 
