      MODULE line_dat_M 
! HITRAN line parameters
! LNMAX		: MAXIMUM NUMBER OF LINES FROM HITRAN LIST

      USE vast_kind_param
!...Created by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
      USE params_M
      INTEGER :: NGINC                          ! ACTUAL NUMBER OF GASES INCLUDED 
                                                ! IN CALCULATION OTHER THAN THOSE 
                                                ! FIT, IF 0 INCLUDE ALL FOUND  
      INTEGER, PARAMETER :: MAXINC = 10         ! MAX NUMBER OF GASES TO INCLUDE 
                                                ! IN BACKGROUND  
      INTEGER, PARAMETER :: MAXMOLSUB = 15      ! MAX MOLECULAR MASS 
                                                ! SUBSTITUTION VALES

      REAL(DOUBLE), DIMENSION(MAXINC) :: SCLINC ! INITIAL PROFILE SCALE FOR 
                                                ! BACKGROUND GASES 
      CHARACTER, DIMENSION(MAXINC) :: GASINC*7  ! NAMES OF GASES TO INCLUDE
      REAL(DOUBLE), DIMENSION(LNMAX) :: ST296   ! INTENSITY AT STANDARD TEMPERATURE
      REAL(DOUBLE), DIMENSION(LNMAX) :: AAA     ! AIR BROADENING HALFWIDTH
      REAL(DOUBLE), DIMENSION(LNMAX) :: SSS     ! SELF BROADENING HALFWIDTH
      REAL(DOUBLE), DIMENSION(LNMAX) :: AZERO   ! WAVENUMBER
      REAL(DOUBLE), DIMENSION(LNMAX) :: ETWO    ! LOWER STATE ENERGY
      REAL(DOUBLE), DIMENSION(LNMAX) :: GMASS   ! MOLECULAR MASS
      REAL(DOUBLE), DIMENSION(LNMAX) :: PSLIN   ! PRESSURE SHIFT
      REAL(DOUBLE), DIMENSION(LNMAX) :: TDLIN   ! COEFFICIENT TEMP. DEP. AIR H-W
      REAL(DOUBLE), DIMENSION(LNMAX) :: BETA    ! Beta0 for Galatry routine
      REAL(DOUBLE), DIMENSION(2,MAXMOLSUB) :: PLINE 
                                                ! MOLECULAR MASS SUBSTITION PARAMETERS
      INTEGER, DIMENSION(LNMAX) :: LGAS         ! LINE INDEX NUMBER
      INTEGER, DIMENSION(MAXBND) :: LINE1       ! BEGINNING LINE FOR BAND I
      INTEGER, DIMENSION(MAXBND) :: LINE2       ! ENDING LINE FOR BAND I
      INTEGER      :: UFLAG, UGAS
      REAL(DOUBLE) :: UVAL
      LOGICAL :: USEGALATRY                     ! TRUE = USE GALATRY FOR ALL LINES
                                                ! FALSE = USE VOIGT FOR ALL LINES
      INTEGER :: LSHAPEMODEL                    ! USER CHOICE OF LINE SHAPE MODEL
                                                ! 0 = IF ANY LINE IN REGION HAS NON-ZERO BETA0 THEN USE GALATRY FOR ALL LINES
                                                !     OTHERWISE USE VOIGT
                                                ! 1 = FORCE VOIGT FOR ALL LINES 
                                                ! 2 = FORCE GALATRY FOR ALL LINES 
      END MODULE line_dat_M 
