      SUBROUTINE MIXOUT(MAXRET, KVERT) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
      USE params_M 
      USE tfiles_dat_M 
      USE jmix_dat_M
      USE slat_dat_M
      USE molec_dat_M
      USE isotope
      
!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
!...Switches: -yf12               
!  --- CREATES FILE OF REVISED MIXING RATIOS - REVISED FEB 19, 1992
 
      IMPLICIT NONE
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------      
      INTEGER :: MAXRET, KVERT 

!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      INTEGER :: MAXMIX, I, K, J 
      REAL(DOUBLE), DIMENSION(LAYMAX) :: GASMIX 
      CHARACTER :: GNAME*7 
!-----------------------------------------------
!
      DATA MAXMIX/ MOLTOTAL/  
 
      OPEN(UNIT=12, FILE=TFIL12, STATUS='OLD', ERR=666, POSITION='asis') 
      OPEN(UNIT=17, FILE=TFIL17, STATUS='UNKNOWN', ERR=555, POSITION='asis') 
      OPEN(UNIT=22, FILE=TFIL22, STATUS='UNKNOWN', ERR=555, POSITION='asis')       
      
      DO I = 1, MAXMIX 
         READ (12, 501, END=87) GNAME 
         
         IF (MIXFORMAT == 1) THEN 
!  --- NEW FORMAT with flag in file
!  --- LIST IO REQUIRED IF USING SPACE DELIMITED MX FILE (I.E. ZEPHYR2 AND IDL )
            READ (12, *, END=87) (GASMIX(K),K=1,KMAX) 
         ELSE 
!  --- NO FLAG IN FILE
            IF (FIXFORMAT) THEN 
!  --- READ OLD FASTCODE FORMAT
               READ (12, 503, END=87) (GASMIX(K),K=1,KMAX) 
            ELSE 
!  --- LIST IO REQUIRED IF USING SPACE DELIMITED MX FILE (I.E. ZEPHYR2 AND IDL )
               READ (12, *, END=87) (GASMIX(K),K=1,KMAX) 
            ENDIF 
         ENDIF 
!  --- SEE IF THIS GAS ID HAS BEEN USED FOR A ISOTOPE - IF SO CHANGE THE NAME
         DO K = 1, NISOSEP
            IF( I .EQ. NEWID(K) ) GNAME = NEWNAME(K)
         ENDDO
!  --- SEE IF THIS GAS IS A RETRIEVAL GAS
         DO J = 1, NRET 
            IF (GNAME == NAME(IGAS(J))) GOTO 11 
         END DO 
!  --- NOT A RETRIEVAL GAS
         GO TO 13 
!  --- RETRIEVAL GAS, UPDATE MIXING RATIOS
   11    CONTINUE 
         GASMIX(:MAXRET) = X(J,:MAXRET) 
!  --- OUTPUT OF MIXING RATIOS & PARTIAL COLUMNS
   13    CONTINUE 

         WRITE (17, 501) GNAME 
         WRITE (17, 883) (GASMIX(K),K=1,KMAX) 
         WRITE (22, 501) GNAME          
         WRITE (22, 883) (GASMIX(K)*CCC(KVERT,K),K=1,KMAX) 
      END DO 

   87 CONTINUE 

      CLOSE(12) 
      CLOSE(17) 
      CLOSE(22)
      
      RETURN  
  555 CONTINUE 
      WRITE (6, 111) TFIL17 
      STOP  
  666 CONTINUE 
      WRITE (6, 222) TFIL12 
      STOP  
  111 FORMAT(/,' OUTPUT FILE OPEN ERROR IN MIXOUT-UNIT17'/,' Filename: "',A,'"') 
  222 FORMAT(/,' INPUT FILE OPEN ERROR IN MIXOUT-UNIT12'/,' Filename: "',A,'"') 
  501 FORMAT(A7) 
  503 FORMAT(8E10.4) 
!     --- Use next format statement to write fixed format like
!         from fastcode
! 883 FORMAT(8(E10.4))
! 883 FORMAT(8(E10.4,1x))
  883 FORMAT(6(ES12.4)) 
      RETURN  
      END SUBROUTINE MIXOUT 
