      SUBROUTINE OPTLIN
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE vast_kind_param
      USE params_M
      USE jmix_dat_M
      USE slat_dat_M
      USE line_dat_M
      USE bands_dat_M
      USE tfiles_dat_M
      USE molec_dat_M
      USE isotope

!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03
!...Switches: -yf12

      IMPLICIT NONE
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      INTEGER :: LOOPTP, LINE, NLINES, IREAD, IBAND, LOWAV, MOWAV, LINFIL, IWAV&
         , ISO, MO, L, K, I, NUMLIN
      REAL(DOUBLE), DIMENSION(MOLTOTAL) :: AMASS
      REAL(DOUBLE), DIMENSION(LAYMAX) :: FXGAS
      REAL(DOUBLE) :: VMRSCL = 1.0D0, WAVLO, WAVHI, PS, TW, ELOWER, SW, AW, &
         SLINE, WAVNUM, DENLIN, B0
      LOGICAL :: SKIPGAS
      CHARACTER :: TFIL14*220, FNAME*10, GNAME*7, CHLINE*200
      INTEGER, DIMENSION(MAXGAS) :: NMOLINE

      SAVE VMRSCL
!-----------------------------------------------
!
!     CHARACTER*50 TFIL14
!
      DATA LOOPTP/ 200000 /

!  --- EXTRACT LINES FROM TAPE14 FOR SPECTRAL BANDPASSES
!  --- LINES ARE ASSUMED TO BE IN ASCENDING WAVENUMBER ORDER
!  --- REVISED SEPT 24, 1996
!

      OPEN(UNIT=12, FILE=TFIL12, STATUS='OLD', ERR=666, POSITION='asis')
!     --- Check MIX file format
!     --- IF get MIXFORMAT flag then new with LIST I/O
!     --- IF no MIXFORMAT flag (=0) then check
!     --- for fixed format
      WRITE (16, *)
      FIXFORMAT = .FALSE.
!     --- evaluate characters instead of reading mixformat
!         as a number in case there is a title after mol name
!         that would cause a number read error.
      READ (12, '(A)') CHLINE
      IF (CHLINE(8:12)=='    1' .AND. LEN_TRIM(CHLINE)==12) THEN
         MIXFORMAT = 1
      ELSE
         MIXFORMAT = 0
      ENDIF
      IF (MIXFORMAT == 0) THEN
         READ (12, '(A)') CHLINE
         IF (CHLINE(2:2)=='.' .AND. CHLINE(12:12)=='.' .AND. CHLINE(22:22)=='.'&
             .AND. CHLINE(32:32)=='.' .AND. CHLINE(42:42)=='.' .AND. CHLINE(52:&
            52)=='.' .AND. CHLINE(62:62)=='.' .AND. CHLINE(72:72)=='.') THEN
!          --- Assumes there are at least 8 layers, then
!          --- it is a fixed format file
            FIXFORMAT = .TRUE.
            WRITE (16, *) 'MIX file will be read (8E10.4)'
         ELSE
            WRITE (16, *) 'MIX file will be read LIST I/O'
         ENDIF
      ELSE
         WRITE (16, *) 'MIX file will be read LIST I/O'
      ENDIF

      REWIND 12
      IFMIX(:MAXGAS)=0
      NGAS = 0
      NLINES = 0
      IREAD = 0
      IF (LSHAPEMODEL == 2) THEN
        USEGALATRY = .TRUE.
      ELSE
        ! DEFAULT TO NOT USE GALATRY, BUT IF LSHAPEMODEL=0 THEN IT COULD BE CHANGED BELOW
        USEGALATRY = .FALSE.
      ENDIF
      L600: DO IBAND = 1, NBAND

!  --- INTERVAL FOR INPUT OF LINE DATA
         WAVLO = WAVE5(IBAND)
         WAVHI = WAVE6(IBAND)
         IF (IBAND /= 1) THEN

!  --- AVOID OVERLAP
         IF (WAVE5(IBAND) <= WAVE6(IBAND-1)) WAVLO = WAVE6(IBAND-1)
         ENDIF
         WRITE (16, 300) IBAND, WAVLO, WAVHI

!  --- DEFINE LOWWAV, MOWAV INDEXES FOR READING CFGL FILES
         LOWAV = FLOOR(WAVLO/20.D0 + 0.0000001D+00)
         MOWAV = FLOOR(WAVHI/20.D0 + 0.0000001D+00)
         DO LINFIL = LOWAV, MOWAV
            IWAV = 20*LINFIL

!  --- READING MODIFIED AFGL LINE FILE
            SELECT CASE ( IWAV )
            CASE ( :999 )
               WRITE (FNAME, '("cfgl",I3)') IWAV
            CASE ( 1000:9999 )
               WRITE (FNAME, '("cfgl",I4)') IWAV
            CASE ( 10000:99999 )
               WRITE (FNAME, '("cfgl",I5)') IWAV
            CASE DEFAULT
               STOP "OPTLIN: cfgl FILENAME ERROR"
            END SELECT
            WRITE (TFIL14, 502) LINDIR(1:LEN_TRIM(LINDIR))//FNAME
            WRITE (*, 120) TFIL14(1:LEN_TRIM(TFIL14))

!  --- OUTPUT LINE DATA FILE NAME
            WRITE (16, 120) TFIL14(1:LEN_TRIM(TFIL14))
            OPEN(UNIT=14, FILE=TFIL14, STATUS='OLD', ERR=669, POSITION='asis')
            REWIND 14
            DO LINE = 1, LOOPTP
               IF (LINE == LOOPTP) THEN
                  WRITE (16,800) LOOPTP
                  CLOSE(16)
                  STOP 'ABORT !!! OPTLIN'
               ENDIF
               SKIPGAS = .FALSE.
               VMRSCL = 1.0D0

!  --- READ HITRAN FORMAT LINE LIST (MODIFIED MOLECULE NUMBERS)
               READ (14, '(A)', END=230) CHLINE
               IF (CHLINE(75:100) /= "                          ") THEN
        ! old cfgl lines with data out to 100 chars so there will be no BETA0 value
                  READ (CHLINE, 107, END=230) MO, ISO, WAVNUM, SLINE, AW, SW, ELOWER, &
                     TW, PS
                  B0=0.0
               ELSE
                  READ (CHLINE, 107, END=230) MO, ISO, WAVNUM, SLINE, AW, SW, ELOWER, &
                    TW, PS, B0
               ENDIF

!  --- CHECK FOR ISOTOPE SEPARATION
!  --- ALSO SCALE LINE INTENSITY - OR NOT, SCALE IS FROM ISOTOPE.INP
               DO I=1, NISOSEP
                   IF((MO .EQ. OLDID(I)) .AND. (ISO .EQ. OLDISO(I)))THEN
                      SLINE = SLINE / ISOSCALE(I)
                      WRITE(16,303) MO, ISO, NEWID(I), NEWISO(I), WAVNUM, SLINE*ISOSCALE(I), ELOWER, &
                                     SLINE
                       MO = NEWID(I)
                       ISO = NEWISO(I)
                   ENDIF
               ENDDO

!  --- CHECK FOR MOL ID OUT OF BOUNDS
               IF (MO > MOLTOTAL) GO TO 665
               IF (WAVNUM < WAVLO) CYCLE
               IF (WAVNUM > WAVHI) CYCLE  L600

!  --- SKIP LINES IF WE ARE SELECTING NONFIT GASES
!  --- BUT FIRST DON'T BOTHER TO CHECK IF WE ARE RETERIEVING THIS GAS
               IF (NGINC /= 0) THEN
                  DO I = 1, NRET
                     IF (MO == IGAS(I)) GO TO 228
                  END DO

                  DO I = 1, NGINC
                     IF (GASINC(I) /= NAME(MO)) CYCLE
                     VMRSCL = SCLINC(I)
                     GO TO 228
                  END DO
                  SKIPGAS = .TRUE.
               ENDIF

!  --- IDENTIFY SPECIES AND STORE AFGL CODE IN ARRAY ICODE
  228          CONTINUE
               IF (NGAS <= 0) THEN
                  !print *, 'ngas', ngas
                  NGAS = 1
                  ICODE(NGAS) = MO        ! STORE HITRAN ID
                  ISCODE(NGAS) = ISO      ! STORE HITRAN ID2
                  NMOLINE(NGAS) = 1    ! STORE # OF LINES FOR THIS MOLECULE
                  GO TO 2268
               ENDIF

!  --- CHECK IF WE ALREADY HAVE A LINE OF THIS GAS (AND ITS PROFILE)
               DO L = 1, NGAS
                  IF (ICODE(L) == MO) THEN
                     NMOLINE(L) = NMOLINE(L) + 1
                     GOTO 2269
                  ENDIF
               END DO

!  --- NEW GAS-ADD TO LIST
               NGAS = NGAS + 1
               IF (NGAS > MAXGAS) GO TO 670
               ICODE(NGAS) = MO
               ISCODE(NGAS) = ISO
               NMOLINE(NGAS) = 1

!  --- READ IN GAS MIXING RATIO PROFILE FROM TAPE12
 2268          CONTINUE
               IF (SKIPGAS) GO TO 86

!  --- IF THIS IS A SEPARATED ISOTOPE MOLECULE WE ALREADY HAVE THE VMR
               DO I=1, NISOSEP
                   IF( MO .EQ. NEWID(I) ) THEN
                       !print *, newvmr
                       FXGAS(:KMAX) = NEWVMR(:KMAX,I)
                       GOTO 84
                   ENDIF
               ENDDO

!  --- LOOP THROUGH MIXING RATIO FILE FOR OUR GAS
               REWIND 12
   83          CONTINUE

               IREAD = IREAD + 1
               READ (12, 501, END=87) GNAME
               IF (MIXFORMAT == 1) THEN
!  --- NEW FORMAT WITH FLAG IN FILE
!  --- LIST IO REQUIRED IF USING SPACE DELIMITED MX FILE
!      (I.E. ZEPHYR2 AND IDL )
                  READ (12, *, END=87) (FXGAS(K),K=1,KMAX)
               ELSE
!  --- NO FLAG IN FILE
                  IF (FIXFORMAT) THEN
!  --- READ OLD FASTCODE FORMAT
                     READ (12, 503, END=87) (FXGAS(K),K=1,KMAX)
                  ELSE
!  --- LIST IO REQUIRED IF USING SPACE DELIMITED MX FILE
!      (I.E. ZEPHYR2 AND IDL )
                     READ (12, *, END=87) (FXGAS(K),K=1,KMAX)
                  ENDIF
               ENDIF
               IF (GNAME /= NAME(ICODE(NGAS))) GO TO 83

!  --- FOUND GAS SO SAVE IT
   84          CONTINUE
               XGAS(NGAS,:KMAX) = FXGAS(:KMAX)*VMRSCL
               IFMIX(NGAS) = 1
               IF( SUM(FXGAS(:KMAX)) <= 0.0D0 ) IFMIX(NGAS) = 0

!  --- ADD LINE TO LIST
               NLINES = NLINES + 1
               LGAS(NLINES) = NGAS
               GO TO 2270

!  --- MIXING RATIO PROFILE NOT FOUND FOR NEW GAS--SET VMRS AND IFMIX TO ZERO
!  --- DON'T ADD LINE TO LINELIST
   87          CONTINUE
               WRITE (16, 88) NAME(ICODE(NGAS))
   86          XGAS(NGAS,:KMAX) = 0.D0
               IFMIX(NGAS) = 0
               CYCLE

!  --- "OLD" GAS - TEST IF VMRS ARE ZERO - IF SO, DON'T ADD LINE
 2269          CONTINUE
               IF (IFMIX(L) == 0) CYCLE

!  --- NONZERO VMRS FOR GAS--ADD LINE TO LIST
               NLINES = NLINES + 1
               LGAS(NLINES) = L

 2270          CONTINUE
               IF (NLINES > LNMAX) GO TO 7
               AZERO(NLINES) = WAVNUM
               IF( UFLAG .EQ. 1 ) THEN
                     IF( MO .EQ. UGAS ) THEN
                  PRINT *, ' CHANGING LINE STRENGTH : ', NAME(UGAS), '  ',UGAS, '  ', UVAL, ' !!!!!!!!!!!!!!!!!!!!!!!!'
                  SLINE = SLINE + UVAL*SLINE
                     ENDIF
               ENDIF
               IF( UFLAG .EQ. 2 ) THEN
                     IF( MO .EQ. UGAS ) THEN
                  PRINT *, ' CHANGING Air-broadened .5-width : ', NAME(UGAS), '  ',UGAS, '  ', UVAL, ' !!!!!!!!!!!!!!!!!!!!!!!!'
                  AW = AW + UVAL*AW
                     ENDIF
               ENDIF
               ST296(NLINES) = SLINE
               AAA(NLINES) = AW
               SSS(NLINES) = SW
               ETWO(NLINES) = ELOWER
               TDLIN(NLINES) = TW
               PSLIN(NLINES) = PS
               BETA(NLINES) = B0
               IF (B0 /= 0.0 .AND. LSHAPEMODEL == 0) THEN
                 USEGALATRY=.TRUE.
               ENDIF

!  --- CHECK TO BE SURE ISOTOPIC MOLECULAR WEIGHT IS DEFINED
               IF (ISO > NHIISO(ICODE(LGAS(NLINES)))) GO TO 668
               GMASS(NLINES) = XMASS(ISO,MO)

!  --- SUBSTITUTE MOLECULAR MASS IF NEEDED
               DO I = 1, 15
!                 CMPEPSILON used for comparison IF (MO .NE. PLINE(1,I)) THEN
                  IF (ABS(MO - PLINE(1,I)) > ABS(MO + PLINE(1,I))*CMPEPSILON) &
                     CYCLE
                  GMASS(NLINES) = PLINE(2,I)
               END DO

!  --- SAVE MASS USED IN CALCULATIONS FOR A CHECK - MAIN ISOTOPE
               AMASS(MO) = XMASS(1,MO)

!  --- CONVERSION OF LINE STRENGTH TO CM-2ATM-1 UNITS
               ST296(NLINES) = ST296(NLINES)*SCHMIT*ZEROC/STDTEMP
                        ! LOOP OVER LINES IN A FILE
            END DO
  230       CONTINUE
            CLOSE(14)
                        ! LOOP OVER CFGL FILES
         END DO
                        ! LOOP OVER BANDS
      END DO L600

      NUMLIN = NLINES
      WRITE (16, 886) NUMLIN
!  --- TEST TO BE SURE LINE LIST ISN'T EMPTY
      IF (NUMLIN <= 0) GO TO 667

      DO I = 1, NGAS
         IF (IFMIX(I) == 0) THEN
            WRITE (16, 700) NAME(ICODE(I))
         ELSE
            WRITE (16, 710) NAME(ICODE(I))
         ENDIF
      END DO

      WRITE (16, 891) NGAS
!  --- OUTPUT NUMBER OF GASES USED
      WRITE (16, 892) SUM( IFMIX )

!  --- PRINT ONLY THOSE PROFILES USED TO DETAIL
      DO I = 1, NGAS
         IF (IFMIX(I) == 0) CYCLE
         WRITE (16, 882) NAME(ICODE(I)), ICODE(I), AMASS(ICODE(I)), NMOLINE(I)
         WRITE (16, 884) (XGAS(I,K),K=1,KMAX)
      END DO

      DENLIN = NLINES/(WAVHI - WAVLO)
      WRITE (16, 887) DENLIN
      IF (DENLIN>500 .AND. DENLIN<1000.) THEN
         TAUMIN = 1.E-07
         WRITE (16, 888) TAUMIN
      ELSE IF (DENLIN >= 1000) THEN
         TAUMIN = 1.E-08
         WRITE (16, 889) TAUMIN
      ELSE
         WRITE (16, 890) TAUMIN
      ENDIF
      CLOSE(12)
      CLOSE(14)

!  --- DETERMINE RANGE OF LINES TO CONSIDER FOR EACH BANDPASS
      WRITE (16, 301)
      DO IBAND = 1, NBAND
         IF (NSCAN(IBAND) == 0) CYCLE
         NLINES = 0
         DO I = 1, NUMLIN
            IF (AZERO(I) < WAVE5(IBAND)) CYCLE
            IF (AZERO(I) >= WAVE6(IBAND)) CYCLE
            NLINES = NLINES + 1
            IF (NLINES == 1) LINE1(IBAND) = I
            LINE2(IBAND) = I
         END DO
         IF (NLINES == 0) GO TO 667
         WRITE (16, 302) IBAND, WAVE5(IBAND), LINE1(IBAND), WAVE6(IBAND), LINE2&
            (IBAND)
      END DO
      IF (USEGALATRY) THEN
         WRITE (16, *) 'Using GALATRY line shape model'
      ELSE
         WRITE (16, *) 'Using VOIGT line shape model'
      ENDIF
      RETURN
    7 CONTINUE
      WRITE (16, 112) LNMAX
      CLOSE(16)
      STOP 'ABORT !!! OPTLIN'
  665 CONTINUE
      WRITE (16, 110) MO
      CLOSE(16)
      STOP 'ABORT !!! OPTLIN'
  666 CONTINUE
      WRITE (16, 111) TFIL12
      CLOSE(16)
      STOP 'ABORT !!! OPTLIN'
  667 CONTINUE
      WRITE (16, 101) IBAND
      CLOSE(16)
      STOP 'ABORT !!! OPTLIN'
  668 CONTINUE
      WRITE (16, 102) LINE, ICODE(LGAS(NLINES)), ISO, NHIISO(ICODE(LGAS(NLINES)))
      WRITE (16, 103) AZERO(LINE)
      CLOSE(16)
      STOP 'ABORT !!! OPTLIN'
  669 CONTINUE
      WRITE (16, 113) TFIL14
      CLOSE(16)
      STOP 'ABORT !!! OPTLIN'
  670 CONTINUE
      WRITE (16, 114) MAXGAS
      CLOSE(16)
      STOP 'ABORT !!! OPTLIN'


   88 FORMAT(A7,': MIXING RATIO NOT FOUND TAPE12, SET TO ZERO FOR ALL LAYERS')
  101 FORMAT(' ABORT *** NO LINES FOR BANDPASS #',I3)
  102 FORMAT(/,' ABORT *** ISOTOPE CODE OUT OF RANGE',/,&
         ' ERROR MESSAGE FROM SUBROUTINE OPTLIN',/,' LINE # =',I5,&
         ' MOLECULE # =',I3,' ISOTOPE # =',I2,/,' MAXIMUM ISOTOPE # =',I2)
  103 FORMAT(/,' LINE POSITION =',F10.4)
  107 FORMAT(I2,I1,F12.6,1P,E10.3,10X,0P,F5.4,F5.4,F10.4,F4.2,F8.6,F7.4)
  110 FORMAT(' ABORT !!! OPTLIN - MOLECULE ID OUT OF BOUNDS: ',I4)
  111 FORMAT(' INPUT FILE OPEN ERROR UNIT 12-INPUT VMR FILE'/,' Filename: "',A,&
         '"')
  112 FORMAT(/,' ABORT !!! NUMBER OF LINES EXCEEDS ',I8)
! 113 FORMAT(/' INPUT FILE OPEN ERROR UNIT 14-LINE FILE = ',A20)
  113 FORMAT(/,' INPUT FILE OPEN ERROR UNIT 14-LINE FILE = "',A,'"')
  114 FORMAT(/,' ABORT !!! NUMBER OF MOLECULES EXCEEDS',I5)
!  115 FORMAT(/,' ABORT !!! UNABLE TO OPEN ISOTOPE PARAMETER INPUT FILE',a)

! 120  FORMAT( 'LINE PARAMETER FILE : ', A )
  120 FORMAT('    File : ',A)


  300 FORMAT(/,' BANDPASS # =',I2,' SEARCH LIMITS FOR LINES=',2F12.6)
  301 FORMAT(/,' WAVENUMBER LIMITS AND INDICES FOR INCLUDED LINES',/,&
         ' BANDPASS   LOWER NU LIMIT  INDEX1     UPPER NU LIMIT  INDEX2')
  302 FORMAT(I6,F18.5,I9,F17.5,I11)
  303 FORMAT('Isotope Line Change : ', I2.2,'/',I2.2,'->',I2.2,'/',I2.2,F14.6,1P,E12.4,0P,F10.4,' ->',1P,E12.4,0P)
  501 FORMAT(A7,I5)
! 502 format(a50)
  502 FORMAT(A)
  503 FORMAT(8E10.4)
  700 FORMAT('           ZERO GAS : ',A,' NO EFFECT IN CALCULATION')
  710 FORMAT('          USING GAS : ',A)
 800  FORMAT('LOOPTP OF ',I10,' EXCEEDED, SO CFGL WOULD BE TRUNCATED -- ABORTING')
!  881 FORMAT(6(E12.0))
! 882 FORMAT(/' MIXING RATIO PROFILE FOR ',A7/)
  882 FORMAT(/,' MIXING RATIO PROFILE FOR: ',A7,' ID: ',I2,' MASS:',F6.1, &
                 ' LINES:', I5)
!  883 FORMAT(8E10.4)
! 884 FORMAT(10E12.4)
  884 FORMAT(6(1P,E12.4))
  886 FORMAT(/,' TOTAL NUMBER OF LINES IN ANALYSIS LIST       : ',I6)
  887 FORMAT(/,' LINE DENSITY (LINES/WAVENUMBER)              : ',F7.1)
  888 FORMAT(' GT.500 LINES-WAVENUMBER-TAUMIN DECREASED TO  : ',1P,D9.2)
  889 FORMAT(' GT.1000 LINES-WAVENUMBER-TAUMIN DECREASED TO : ',1P,D9.2)
  890 FORMAT(' TAUMIN DEFINED AS                            : ',1P,D9.2)
  891 FORMAT(/,' NUMBER OF GASES FOUND IN MICROWINDOWS        : ',I2)
  892 FORMAT(' NUMBER OF GASES INCLUDED IN CALCULATION      : ',I2)
      RETURN
      END SUBROUTINE OPTLIN
