      MODULE params_M

      USE vast_kind_param

      CHARACTER*44, PARAMETER :: VERSION = 'SFIT2 V3.94W3 JUL 2011'

!      LOGICAL, PARAMETER :: OUTPUT_CHANNEL_FILES = .TRUE.
      LOGICAL, PARAMETER :: OUTPUT_CHANNEL_FILES = .FALSE.
!      LOGICAL, PARAMETER :: OUTPUT_SEFILE = .TRUE.
      LOGICAL, PARAMETER :: OUTPUT_SEFILE = .FALSE.
!      LOGICAL, PARAMETER :: BUG = .TRUE.
      LOGICAL, PARAMETER :: BUG = .FALSE.

      INTEGER, PARAMETER :: MMAX = 2*131072       ! MAXIMUM NUMBER OF SPECTRAL DATA POINTS
      INTEGER, PARAMETER :: NMAX = 255            ! MAXIMUM NUMBER OF FITTING PARAMETERS
      INTEGER, PARAMETER :: MOLMAX = 10           ! MAXIMUM NUMBER OF RETRIEVAL GASES
      INTEGER, PARAMETER :: LAYMAX = 70           ! MAXIMUM NUMBER OF ATMOSPHERIC LAYERS
      INTEGER, PARAMETER :: MAXSPE = 40           ! MAXIMUM NUMBER OF SPECTRA
      INTEGER, PARAMETER :: MAXGAS = 40           ! MAXIMUM NUMBER OF GASES IN BANDPASS
      INTEGER, PARAMETER :: LNMAX = 2*131072      ! MAXIMUM NUMBER OF LINES
      INTEGER, PARAMETER :: MAXPRF = 4            ! MAXIMUM NUMBER OF PROFILE RETRIEVALS
      INTEGER, PARAMETER :: MAXBND = 125          ! MAXIMUM NUMBER OF BANDPASSES
!      INTEGER MAXCROSS                           ! MAXIMUM NUMBER OF MONOCHROMATIC
!                                                 !  POINTS/BANDPASS (NOW SET AT RUNTIME)
      INTEGER, PARAMETER :: MAXSNR = 20           ! MAXIMUM NUMBER OF ALTERNATE S/N VALUES
      INTEGER, PARAMETER :: LNMXCO = 131072       ! MAXIMUM NUMBER OF SOLAR CO LINES
      INTEGER, PARAMETER :: MAXEAP = 2000         ! EMPIRICAL APODIZTION POINTS
      INTEGER, PARAMETER :: MOLTOTAL = 99         ! TOTAL NUMBER OF POSSIBLE MOLECULES
      INTEGER, PARAMETER :: MAX_NUM_OF_BEAMS = 10 ! MAX NUMBER OF BEAMS FOR A BANDPASS  !pwj
                                                  ! WUJIAN PENG added on July, 2002     !pwj
      INTEGER, PARAMETER :: ISOMAX = 5            ! MAXIMUM NUMBER OF SEPARATED ISOTOPE SPECIES


! Numerical Constants
! Phys. Today Aug 2001


      REAL(DOUBLE), PARAMETER :: PI = 3.141592653589793D0
      REAL(DOUBLE), PARAMETER :: SCHMIT = 2.6867775D+19
      REAL(DOUBLE), PARAMETER :: ALOGSQ = 0.8325546111576978D0
      REAL(DOUBLE), PARAMETER :: PISQ = 1.7724538509083950D0
      REAL(DOUBLE), PARAMETER :: RFACTOR = 3.581165292D-7
      REAL(DOUBLE), PARAMETER :: RCONST2 = 1.4387752D0
      REAL(DOUBLE), PARAMETER :: STDTEMP = 296.0D0
      REAL(DOUBLE), PARAMETER :: ZEROC = 273.150D0
      REAL(DOUBLE), PARAMETER :: BAR = 1013.250D0


!  ********************************************************************
!   CMPEPSILON is the epsilon used in floating point comparisons
!              instead of checking for equality between floating point
!              numbers.
!              instead of if (x .eq. y) we use
!              if (ABS(x-y) .LE. (ABS(x+y)*CMPEPSILON))
      REAL(DOUBLE), PARAMETER :: CMPEPSILON = 0.0000000000000005
      END MODULE params_M
