      SUBROUTINE QVIB 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
      USE params_M 
      USE jmix_dat_M
      USE slat_dat_M
      USE vibfn_dat_M
      USE molec_dat_M
!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
!...Switches: -yf12               
 
!  COMPUTE VIBRATIONAL PARTITION FUNCTION FOR RETRIEVAL AND BACKGROUND
!  GASES FOR EACH LAYER TEMPERATURE AND AT THE REFERENCE TEMPERATURE
!  296 K.  THIS SUBROUTINE IS BASED ON FASCOD1C
!
!     NMODE=NUMBER OF VIBRATIONAL MODES
!           TORSIONAL MODES NOT INCLUDED -- C2H6(#38), CLONO2 (#27)
!     IVIB=ARRAY CONTAINING FUNDAMENTAL FREQUENCIES AND DEGENERACIES
 
      IMPLICIT NONE
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      INTEGER :: KLEVEL, I, K, N, IMODE, ISUBS(MAXSPE) 
      REAL(DOUBLE) :: TEMP, FREQ 
!-----------------------------------------------
!
 
      KLEVEL = KMAX + 1 
      DO I = 1, NGAS 
!  --- ICODE=PC GAS CODE (1=H2O,2=CO2,ETC.)
         IF( IFMIX(I) == 0 ) CYCLE
         DO K = 1, KLEVEL 
            QV(I,K) = 1.D0 
            IF (ICODE(I) - MOLTOTAL > 0) CYCLE  
            IF (K <= KMAX) TEMP = T(K) 
            IF (K == KLEVEL) TEMP = 296.D0 
            N = NMODE(ICODE(I)) 
            DO IMODE = 1, N 
               FREQ = IVIB(1,IMODE,ICODE(I)) 
               QV(I,K) = QV(I,K)/(1.D0 - EXP((-RCONST2*FREQ/TEMP)))**IVIB(2,&
                  IMODE,ICODE(I)) 
            END DO 
         END DO 
      END DO 

!  --- GET INDEXES OF NGAS THAT WE ARE ACTUALLY USING
      N = 0
      DO I=1, NGAS
         IF( IFMIX(I) == 0 ) CYCLE
          N = N + 1
         ISUBS(N) = I
      END DO   


!  --- WRITE OUT VIBRATIONAL PARTITION FUNCTIONS
      WRITE (16, 100) 
      WRITE (16, 5, ADVANCE='no') 
      WRITE(16, 6) NAME(ICODE(ISUBS(:N)))
      DO K = 1, KLEVEL 
         IF (K <= KMAX) TEMP = T(K) 
         IF (K == KLEVEL) TEMP = 296.D0 
         WRITE (16, 7, ADVANCE='no') TEMP 
         WRITE(16, 9) QV(ISUBS(:N),K)
      END DO 

      RETURN  
    5 FORMAT(' TEMP    ') 
    6 FORMAT(7(2X,A7)) 
    7 FORMAT(F8.2,':') 
    9 FORMAT(7(F8.4,1X)) 
  100 FORMAT(/,' VIBRATIONAL PARTITION FUNCTION FOR GASES'/) 

      END SUBROUTINE QVIB 
