      SUBROUTINE QXZ136(Z, M, IWK) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
!-FFRDR2--------S-------LIBRARY 3---------------------------------------
!
!***********************************************************************
!
!   FUNCTION            - THIS SUBROUTINE PERMUTES A COMPLEX DATA VECTOR
!                           IN REVERSE BINARY ORDER TO NORMAL ORDER. THE
!                           ROUTINE CAN ALSO BE USED TO PERMUTE A COM-
!                           PLEX DATA VECTOR IN NORMAL ORDER TO REVERSE
!                           BINARY ORDER SINCE THE PERMUTATION IS SYM-
!                           METRIC.
!   USAGE               - CALL QXZ136(Z,M,IWK)
!   PARAMETERS  Z       - COMPLEX VECTOR OF LENGTH N=2**M WHICH
!                           CONTAINS ON INPUT THE DATA TO BE
!                           PERMUTED. ON OUTPUT, Z CONTAINS THE
!                           PERMUTED DATA VECTOR.
!                M      - N=2**M IS THE NUMBER OF DATA POINTS.
!                IWK    - WORK AREA VECTOR OF LENGTH M+1
!   PRECISION           - SINGLE
!   LANGUAGE            - FORTRAN
!   LATEST REVISION     - MARCH 16, 1973
!     -----------------------------------------------------------------
!
!      IMPLICIT REAL*8 (A-H,O-Z)
!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
!...Switches: -yf12               
      IMPLICIT NONE
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      INTEGER :: M 
      INTEGER :: IWK(*) 
      COMPLEX(DBLE_COMPLEX) :: Z(*) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      INTEGER :: MP, JJ, I, N2, N4, N8, LM, NN, J, JK, K 
      COMPLEX(DBLE_COMPLEX) :: TEMP 
!-----------------------------------------------
!
      IF (M > 1) THEN 
         MP = M + 1 
         JJ = 1 
!                                  INITIALIZE WORK VECTOR
         IWK(1) = 1 
         DO I = 2, MP 
            IWK(I) = IWK(I-1)*2 
         END DO 
         N4 = IWK(MP-2) 
         IF (M > 2) N8 = IWK(MP-3) 
         N2 = IWK(MP-1) 
         LM = N2 
         NN = IWK(MP) + 1 
         MP = MP - 4 
!                                  DETERMINE INDICES AND SWITCH A*S
         J = 2 
   10    CONTINUE 
         JK = JJ + N2 
         TEMP = Z(J) 
         Z(J) = Z(JK) 
         Z(JK) = TEMP 
         J = J + 1 
         IF (JJ <= N4) THEN 
            JJ = JJ + N4 
         ELSE 
            JJ = JJ - N4 
            IF (JJ <= N8) THEN 
               JJ = JJ + N8 
            ELSE 
               JJ = JJ - N8 
               K = MP 
               DO WHILE(IWK(K) < JJ) 
                  JJ = JJ - IWK(K) 
                  K = K - 1 
               END DO 
               JJ = IWK(K) + JJ 
            ENDIF 
         ENDIF 
         IF (JJ > J) THEN 
            K = NN - J 
            JK = NN - JJ 
            TEMP = Z(J) 
            Z(J) = Z(JJ) 
            Z(JJ) = TEMP 
            TEMP = Z(K) 
            Z(K) = Z(JK) 
            Z(JK) = TEMP 
         ENDIF 
         J = J + 1 
!                                  CYCLE REPEATED UNTIL LIMITING NUMBER
!                                    OF CHANGES IS ACHIEVED
         IF (J <= LM) GO TO 10 
      ENDIF 
      RETURN  
      END SUBROUTINE QXZ136 
