      SUBROUTINE SETUP 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
      USE params_M 
      USE tfiles_dat_M 
      USE jmix_dat_M
      USE zfft_dat_M
      USE slat_dat_M
      USE bands_dat_M
      USE trans_dat_M 
      USE spec_dat_M
      USE solar
      USE molec_dat_M
      USE xsect_dat_M 

!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
!...Switches: -yf12               
 
!  --- SETUP CALCULATIONS FOR THE VARIOUS BANDPASSES
 
      IMPLICIT NONE
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      INTEGER :: IBAND, N, MAXALT, MINALT, I, J, MINSAV, K, NEXTRA, &
                 NAERR, MAXMPT, JSCAN
      CHARACTER *64 ILSHEAD   
      REAL(DOUBLE) :: DLINES, DWAVE, WAVE1, WAVE2, AN, DUMMY
!-----------------------------------------------
!
!                                               !  POINTS/BANDPASS (NOW
!  --- INTERVAL OUTSIDE REGION FOR INPUT OF LINE DATA
      DATA DLINES/4.0D0/  
!  --- READ DATA FOR EACH BANDPASS.  STORE IN ARRAY TOBS
!  --- ALSO TABULATE LIST OF SCANS BEING FIT IN EACH REGION
!        NSCAN(IBAND)=NUMBER OF SCANS TO BE FIT FOR BANDPASS IBAND
!        ISCAN(IBAND,I))=SPECTRUM CODE FOR THE ITH SCAN FITTED
!        NFITS=TOTAL NUMBER OF SPECTRAL SEGMENTS FITTED
!        MINALT=MINIMUM ALTITUDE FITTED FOR A BANDPASS
!        MAXALT=MAXIMUM ALTITUDE FITTED FOR A BANDPASS
!        NATMOS=TOTAL NUMBER OF DATA POINTS TO BE FITTED
      NFITS = 0 
      NATMOS = 0 
!  --- OPEN ASCII SPECTRAL DATA
      WRITE (*, *) ' Reading ASCII spectra file: ', TFIL15(1:LEN_TRIM(TFIL15)) 
      WRITE (6, *) '   NFIT  BAND  SCAN/BAND  RANGE' 
      OPEN(UNIT=15, FILE=TFIL15, STATUS='OLD', ERR=104, POSITION='asis') 
      L3: DO IBAND = 1, NBAND 
!  --- DETERMINE THE MINIMUM AND MAXIMUM ALTITUDES FOR EACH BANDPASS
         N = NRETB(IBAND) 
         MAXALT = 0 
         MINALT = 200 
         MINALT = MIN0(MINVAL(MINB(IBAND,:N)),MINALT) 
         MAXALT = MAX0(MAXVAL(MAXB(IBAND,:N)),MAXALT) 
         NSCAN(IBAND) = 0 
         
         DO JSCAN = 1, NSPEC 
            ISCNDX(1,IBAND,JSCAN) = NATMOS+ 1
            IF (ISPEC(JSCAN) > MAXALT) THEN
               WRITE(6,*) ISPEC(JSCAN), ' ***OUT OF RANGE : GREATER THAN ', MAXALT
               STOP
               !CYCLE
            ENDIF
            IF (ISPEC(JSCAN) < MINALT) THEN
               WRITE(6,*) ISPEC(JSCAN), ' ***OUT OF RANGE : LESS THAN ', MINALT
               STOP
               !CYCLE L3
            ENDIF
             NSCAN(IBAND) = NSCAN(IBAND) + 1 
            ISCAN(IBAND,NSCAN(IBAND)) = JSCAN 
            NFITS = NFITS + 1 
!  --- GET LINE DATA
 
            WRITE (6, 108) NFITS, IBAND, NSCAN(IBAND), WAVE3(IBAND), WAVE4(&
               IBAND) 
 
            CALL GETSPEC( IBAND, JSCAN, (IBAND==1 .AND. JSCAN==1) )  
            ISCNDX(2,IBAND,JSCAN) = NATMOS
         END DO 
         
         REWIND (15) 
      END DO L3 
      CLOSE(15)

      WRITE (16, 105) NATMOS 
!  --- FOR EACH RETRIEVAL GAS, DETERMINE THE FIRST (UPPERMOST ALTITUDE)
!  --- SCAN TO BE FIT, THE LAST (LOWEST ALTITUDE) SCAN TO BE FIT, AND THE
!  ---  NUMBER OF SPECTRA TO BE FIT
!          MINZ(I)=MINIMUM ALTITUDE RETRIEVED FOR RETRIEVAL GAS I
!          MAXZ(I)=MAXIMUM ALTITUDE RETRIEVED FOR RETRIEVAL GAS I
!          IRETS(I)=SPECTRUM NUMBER OF FIRST SCAN RETRIEVED FOR GAS I
!          IRETF(I)=SPECTRUM NUMBER OF FINAL SCAN RETRIEVED FOR GAS I
!  ---     NUMZ(I)=NUMBER OF ALTITUDES TO BE FIT FOR RETRIEVAL GAS I
      L8: DO I = 1, NRET 
         MAXZ(I) = 0 
         MINZ(I) = 99999 
         NUMZ(I) = 0 
         DO IBAND = 1, NBAND 
            N = NRETB(IBAND) 
            DO J = 1, N 
               IF (IGASB(IBAND,J) /= IGAS(I)) CYCLE  
               MINZ(I) = MIN0(MINB(IBAND,J),MINZ(I)) 
               MAXZ(I) = MAX0(MAXB(IBAND,J),MAXZ(I)) 
            END DO 
         END DO 
         MINSAV = MINZ(I) 
!  --- GO THROUGH LIST OF SPECTRA TO DETERMINE SCANS TO BE FIT
         DO K = 1, NSPEC 
            IF (ISPEC(K) > MAXZ(I)) CYCLE  
            IF (ISPEC(K) < MINSAV) CYCLE  L8 
            NUMZ(I) = NUMZ(I) + 1 
            IF (NUMZ(I) == 1) THEN 
               MAXZ(I) = ISPEC(K) 
               IRETS(I) = K 
            ENDIF 
            MINZ(I) = ISPEC(K) 
            IRETF(I) = K 
         END DO 
         IF (NUMZ(I) == 0) GO TO 100 
      END DO L8 
      
!  --- ADJUST POINT SPACING FOR MONOCHROMATIC CALCULATIONS
!         CHOOSE SPACING SO THAT SPECTRAL DATA POINT SPACING
!         IS A MULTIPLE OF THE MONOCHROMATIC POINT SPACING
      NSPAC = FLOOR(SPAC/DN + 1.0000001D0) 
      DN = SPAC/NSPAC 
      WRITE (16, 566) SPAC, DN, NSPAC 

!  --- COMPUTE INTERVAL FOR MONOCHROMATIC CALCULATIONS FOR EACH BANDPASS
!         ADD ABOUT 10 TIMES THE RESOLUTION TO BOTH SIDESS OF THE INTEGRATION
!         INTERVAL TO ALLOW FOR WAVELENGTH SHIFTS
      DWAVE = 10.D0/PMAX 
      NEXTRA = NINT( DWAVE/DN )
      WRITE (16, 200) 
      MAXMPT = 0 
      DO IBAND = 1, NBAND 
         IF (NSCAN(IBAND) == 0) CYCLE  
         WAVE1 = WSTART(IBAND) - NEXTRA*DN 
         WAVE2 = WSTOP(IBAND) + NEXTRA*DN 
         NSTART(IBAND) = NEXTRA + 1 
         WMON(IBAND) = WAVE1 
         NM(IBAND) = FLOOR((WAVE2 - WAVE1)/DN + 1.000000001D0)
!  --- INTERVAL FOR INPUT OF LINE DATA
         WAVE5(IBAND) = WAVE1 - DLINES 
         WAVE6(IBAND) = WAVE2 + DLINES 
!
!     ESTIMATE 2**M FOR FFT
!
         AN = NM(IBAND) 
         MFFT(IBAND) = FLOOR(LOG(AN)/LOG(2.0D0)) + 1 
         MPT(IBAND) = 2**MFFT(IBAND) 
         IF (MPT(IBAND) > MAXMPT) MAXMPT = MPT(IBAND) 
         LOWFIL(IBAND) = (MPT(IBAND)-NM(IBAND))/2 
         HIFILL(IBAND) = LOWFIL(IBAND) + NM(IBAND) 
         NSTZ1(IBAND) = FLOOR(DN*PMAX*MPT(IBAND)) + 1 
         NSTZ2(IBAND) = MPT(IBAND) - NSTZ1(IBAND) 
         WRITE (16, 201) WSTART(IBAND), WSTOP(IBAND), NM(IBAND), MPT(IBAND), &
            NSTZ1(IBAND) 
      END DO 
      
!  --- COUNT TOTAL NUMBER OF MONOCHROMATIC POINTS (NMONSM)
!  --- AND THE TOTAL NUMBER OF CROSS SECTION POINTS (NCROSS)
!  --- TO BE CALCULATED AND CHECK FOR ARRAY OVERFLOWS
      NMONSM = 0 
      NCROSS = 0 
      NCROSS = SUM(NM(:NBAND)) 
      NMONSM = DOT_PRODUCT(NM(:NBAND),NSCAN(:NBAND)) 
!	print *,'nm(1)=',nm(1),'nm(2)=',nm(2)
!      WRITE(6,220) NATMOS, SPAC, NMONSM, DN, NSPAC
! 220  FORMAT('  NSPEC=',I5,' DS=',F8.6,' NMON=',I6,' DS=',F8.6,' FCTR=',I2 )
      ALLOCATE (CROSS(NRET+1,KMAX,NCROSS), STAT=NAERR) 
      IF (NAERR /= 0) THEN 
         WRITE (6, *) 'Could not allocate CROSS array' 
         WRITE (6, *) 'Error Number = ', NAERR 
         STOP 'SETUP ALLOCATION' 
      ENDIF 
      ALLOCATE (TCO(NCROSS), STAT=NAERR) 
      IF (NAERR /= 0) THEN 
         WRITE (6, *) 'Could not allocate TCO array' 
         WRITE (6, *) 'Error Number = ', NAERR 
         STOP 'SETUP ALLOCATION' 
      ENDIF 
      ALLOCATE (TCONV(NMONSM),STAT=NAERR)
      IF (NAERR /= 0) THEN 
         WRITE (6, *) 'Could not allocate TCONV array' 
         WRITE (6, *) 'Error Number = ', NAERR 
         STOP 'SETUP ALLOCATION' 
      ENDIF 
      ALLOCATE (TCALC(2,NMONSM), STAT=NAERR) 
      IF (NAERR /= 0) THEN 
         WRITE (6, *) 'Could not allocate TCALC array' 
         WRITE (6, *) 'Error Number = ', NAERR 
         STOP 'SETUP ALLOCATION' 
      ENDIF 
      ALLOCATE (IMGG(MAXMPT), STAT=NAERR) 
      IF (NAERR /= 0) THEN 
         WRITE (6, *) 'Could not allocate IMGG array' 
         WRITE (6, *) 'Error Number = ', NAERR 
         STOP 'SETUP ALLOCATION' 
      ENDIF 
      WRITE (16, 212) NMONSM, NCROSS 
      
      IF (IFCO /= 0) THEN 
! ---- STORE CO LINE LIST
         WRITE (*, *) ' Reading Solar line list file...' 
         CALL SOLARFH( 0 ) 
         
! ---- IF NO SOLAR CO LINES FOUND, RESET IFCO=0
         IF (NCOLNS == 0) IFCO = 0 
         
! --- default values to zero in case print below
         EAPX(:MAXEAP) = 0.0 
         EAPF(:MAXEAP) = 0.0 
         EPHSX(:MAXEAP) = 0.0 
         EPHSF(:MAXEAP) = 0.0 
      ENDIF 
      
! --- if using empirical apodization, read parameters
      IF (IEAP > 0) THEN 
         WRITE (*, *) ' Reading empirical modulation parameter file...' 
         OPEN(UNIT=19, FILE=EAPFIL, STATUS='OLD', ERR=109, POSITION='asis') 
         IF (IEAP == 4) THEN 
            ! reads linefit format assumes 20 values)
            JEAP = 20 
            READ (19, '(A64)') ILSHEAD 
            ! don't read ephs here since there could be two different files
            READ (19, *, ERR=120) (EAPX(I),EAPF(I),DUMMY,I=1,JEAP) 
         ELSE 
            ! original file format
            READ (19, *) JEAP 
            READ (19, *) (EAPF(I),I=1,JEAP) 
            WRITE (16, '(/A)') 'Empirical modulation function coefficients' 
            WRITE (16, *) (EAPF(I),I=1,JEAP) 
            IF (IEAP == 1) THEN 
               READ (19, *) (EAPX(I),I=1,JEAP) 
               WRITE (16, *) (EAPX(I),I=1,JEAP) 
            ENDIF 
         ENDIF 
         CLOSE(19) 
      ENDIF 
 
! --- if using empirical phase function, read parameters
      IF (IEPHS > 0) THEN 
         WRITE (*, *) ' Reading empirical phase function file...' 
         OPEN(UNIT=19, FILE=EPHSFIL, STATUS='old', ERR=106, POSITION='asis') 
         IF (IEPHS == 4) THEN 
            ! reads linefit format assumes 20 values)
            JEPHS = 20 
            READ (19, '(A64)') ILSHEAD 
            ! don't read eapf here since there could be two different files
            READ (19, *, ERR=125) (EPHSX(I),DUMMY,EPHSF(I),I=1,JEPHS) 
         ELSE 
            ! original file format
            READ (19, *) JEPHS 
            READ (19, *) (EPHSF(I),I=1,JEPHS) 
            WRITE (16, '(/A)') 'Empirical phase function coefficients' 
            WRITE (16, *) (EPHSF(I),I=1,JEPHS) 
            IF (IEPHS == 1) THEN 
               READ (19, *) (EPHSX(I),I=1,JEPHS) 
               WRITE (16, *) (EPHSX(I),I=1,JEPHS) 
            ENDIF 
         ENDIF 
         CLOSE(19) 
      ENDIF 
      IF (IEAP==4 .OR. IEPHS==4) THEN 
         ! if using both ieap=4 or iephs=4 print as found in one file
         !  which assumes eapx is the same as ephsx
         WRITE (16, 202) JEAP 
         WRITE (16, 203) (EPHSX(I),EAPF(I),EPHSF(I),I=1,JEAP) 
      ENDIF 
 
!  --- RETRIEVE NORTON AND BEER APODIZING COEFFICIENTS
      IF (IAP>=0 .AND. IAP<4) THEN 
         CALL BOBAPD 
      ENDIF 
      
!  --- INPUT ATMOSPHERIC LINE DATA FROM TAPE14
      WRITE (*, *) ' Reading atmospheric line list file(s)...' 
      CALL OPTLIN 
      
!  --- PRINT OUT TDEPENDENCE OF HALFWIDTHS
!      WRITE(16,3661)
!      WRITE(16,3662) (NAME(ICODE(I)),THALF(ICODE(I)),I=1,NGAS)
!  FOR EACH GAS, IDENTIFY IF IT IS A RETRIEVAL GAS.   IF IT IS,
!  STORE THE STARTING PROFILE IN ARRAY XORG
      DO J = 1, NRET 
         DO I = 1, NGAS 
            IF (IGAS(J) == ICODE(I)) GO TO 232 
         END DO 
         WRITE (16, 3663) J 
         STOP  
  232    CONTINUE 
         IRET(J) = I 

! --- CHECK FOR A 0.0 IN AN INITIAL PROFILE TO BE RETRIEVED         
         DO K = 1, KMAX 
            IF (XGAS(I,K) <= 0.0D0) GO TO 107 
            X(J,K) = XGAS(I,K) 
            XORG(J,K) = XGAS(I,K) 
         END DO 
      END DO 
      
!  CALCULATE VIBRATIONAL PARTITION FUNCTION FOR ALL GASES AT EACH LAYER
!  AND AT 296K.
      WRITE (*, *) ' Calculating partition functions...' 
      CALL QVIB 
      
!  COMPUTE CROSS SECTIONS FOR RETRIEVAL AND BACKGROUND GASES
      CALL KROSSR 
      RETURN  
      
  100 CONTINUE 
      WRITE (16, 213) I 
      CLOSE(16) 
      STOP 'ABORT !!! SETUP' 
  104 CONTINUE 
      WRITE (16, 667) TFIL15 
      CLOSE(16) 
      STOP 'ABORT !!! SETUP' 
  109 CONTINUE 
      WRITE (16, *) 'Error opening empirical apodization phase parameter file' 
      WRITE (16, *) 'Filename: "', EAPFIL, '"' 
      CLOSE(16) 
      STOP 'ABORT !!! SETUP' 
  106 CONTINUE 
      WRITE (16, *) 'Error opening empirical phase parameter file' 
      WRITE (16, *) 'Filename: "', EPHSFIL, '"' 
      CLOSE(16) 
      STOP 'ABORT !!! SETUP' 
  107 CONTINUE 
      WRITE (16, 668) NAME(ICODE(I)) 
      CLOSE(16) 
      STOP 'ABORT !!! SETUP' 

  108 FORMAT(I5,2I6,7X,F10.3,'-',F10.3) 
  105 FORMAT(/,' TOTAL NUMBER OF SPECTRAL DATA POINTS TO FIT =',I6) 
 
  120 CONTINUE 
      WRITE (16, 130) JEAP, EAPFIL 
      CLOSE(16) 
  125 CONTINUE 
      WRITE (16, 135) JEPHS, EPHSFIL 
      CLOSE(16) 
      STOP 'ABORT !!! SETUP' 
  130 FORMAT(/,' ABORT -SETUP- Error reading EAP file. ',I5,' value required',/&
         ,' Filename: "',A,'"') 
  135 FORMAT(/,' ABORT -SETUP- Error reading EPHS file. ',I5,' value required',&
         /,' Filename: "',A,'"') 
 
  200 FORMAT(/,'    WSTART     WSTOP    NMON    MPT    NSTZ1') 
  201 FORMAT(2F10.4,I8,I7,I9) 
  202 FORMAT(/,' Tabular form of ILS parameters, Assuming n= ',I3,/,&
         '  OPD    Modulatin       Phase') 
  203 FORMAT(F7.3,2ES12.4) 
  212 FORMAT(' NMONSM =',I6,' NCROSS =',I6) 
  213 FORMAT(/,' ABORT -SETUP- NO SPECTRA SPECIFIED FOR RETRIEVAL GAS #',I2) 
  566 FORMAT(/,' SPECTRUM POINT SPACING (CM-1) =',F12.8,/,&
         ' MONOCHROMATIC POINT SPACING (CM-1) =',F12.8,/,' NSPAC =',I3) 
  667 FORMAT(/,' ABORT -SETUP- ASCII SPECTRAL FILE NOT FOUND'/,' Filename: "',A&
         ,'"') 
  668 FORMAT(/,' ABORT -SETUP- ZERO VMR VALUE FOUND IN PROFILE: ',A7) 
! 3661 FORMAT(/,/,' TEMPERATURE DEPENDENCE OF HALFWIDTHS',/,' GAS        TDEP'/) 
! 3662 FORMAT(1X,A7,F6.2) 
 3663 FORMAT(/,' ABORT -SETUP- NO LINES OR PROFILE FOR RETRIEVAL GAS #',I3) 
      RETURN  
      END SUBROUTINE SETUP 


 
      SUBROUTINE RELEASE_MEM 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
      USE params_M 
      USE zfft_dat_M
      USE trans_dat_M 
      USE solar
      USE xsect_dat_M 
!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
!...Switches: -yf12               
 
      IMPLICIT NONE
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
!-----------------------------------------------
 
      DEALLOCATE (CROSS) 
      DEALLOCATE (TCO) 
      DEALLOCATE (TCONV) 
      DEALLOCATE (TCALC) 
      DEALLOCATE (IMGG) 
      RETURN  
      END SUBROUTINE RELEASE_MEM 
